#include <cstdio>
#include <cstdlib>
#include <climits>
#include <cstring>
#include <algorithm>
#include <set>
#include <utility>
using namespace std;

typedef long long Z;

int N, K;

struct Slv {
	Z dp[500][70];
	int decide[500][70];
	
	Z Ps[500];
	
	void gen () {
		dp [0][0] = 0;
		for (int i = 1; i <= N; i ++)
			for (int c = min(K, i); c >= 1; c --) {
				int dec = -1;
				Z best = LLONG_MAX;
				if (c == 1)
					best = Ps[i] * Ps[i];
				else
					/**/
					for (int pr = max (c-1, decide[i-1][c]); pr < min (i, c == min(K, i) ? i : 1 + decide[i][c+1]); pr ++)
					/*/
					for (int pr = c-1; pr < i; pr ++)
					//*/
					{
						Z cut = dp[pr][c-1] + (Ps[i] - Ps[pr]) * (Ps[i] - Ps[pr]);
						if (cut < best) {
							dec = pr;
							best = cut;
						}
					}
				dp[i][c] = best;
				decide[i][c] = dec;
			}
	}
	
	Z make (Z *vs) {
		memset (dp, 0, sizeof(dp));
		memset (Ps, 0, sizeof(Ps));
		memset (decide, 0, sizeof(decide));
		
		for (int i = 1; i <= N; i ++)
			Ps[i] = Ps[i-1] + vs[i];
		gen ();
		return dp[N][K];
	}
};

Slv sol;

Z vs [700000];

typedef set<Z>::iterator szit;

int main () {
	freopen ("spaceship.in", "r", stdin);
	freopen ("spaceship.out", "w", stdout);
	scanf ("%d%d", &N, &K);
	
	for (int i = 1; i <= N; i ++)
		scanf ("%lld", &vs[i]);
		
	/**
	//*/if (N <= 1000 || K >= 6) 
	{
		for (int i = 1; i <= N; i ++)
			vs[i + N] = vs[i];
			
		long long val = LLONG_MAX;
		
		for (int i = 1; i <= N; i ++)
			val = min (val, sol.make(vs + i - 1));

		Z sum = 0;
		
		for (int i = 1; i <= N; i ++)
			sum += vs[i];
	
		printf ("%lld\n", K * (K * val - sum * sum));
	}
	/**
	//*/else
	{
		set<Z> S;
		S.insert(0);
		
		Z sum = 0;
		
		for (int i = 1; i <= N; i ++) {
			sum += vs[i];
			S.insert(sum * 2); 
		}
		
		//fprintf (stderr, "%lld ==\n", sum);
		Z mmm = LLONG_MAX;
		
		for (szit it = S.begin(); it != S.end(); it ++) {
			//fprintf (stderr, "%lld\n", *it);
			szit il = S.lower_bound(sum + *it);
			szit ir = S.upper_bound(sum + *it);
			if (il != S.end()) mmm = min (mmm, abs (*it - *il));
			if (ir != S.end()) mmm = min (mmm, abs (*ir - *it));
		}
		printf ("%lld\n", K * (sum - mmm) * (sum - mmm));
	}
	return 0;
}

