#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <string>
using namespace std;
struct Node
{
	int max,min;
	int a,b;
	Node *left;
	Node *right;
};

class Tree
{
	private:
		Node *_root;
		Node* f(int start,int end,int *ar,Node *root);
	
	public:
		Tree(int *a,int length)
		{
			_root = new Node;
			f(1,length,a,_root);
		}//(1-n)
		//void insert(int pos,int val);
		//int remove(int pos);
		int getmin(int a,int b,Node *root);
		int getmax(int a,int b,Node *root);
};
	Node* Tree::f(int start,int end,int *ar,Node *root)
	{
		root-> a = start;
		root-> b = end;
		if(start == end)
		{
			root->max = ar[start];
			root->min = ar[start];
			root->left = NULL;
			root->right = NULL;
		}
		else if(start == end-1)
		{
			root->left = f(start,start,ar,new Node);
			root->right = f(end,end,ar,new Node);
			root->max = max(root->left->max,root->right->max);
			root->min = min(root->left->min,root->right->min);
		}
		else
		{
			root->left = f(start,(start+end)/2,ar,new Node);
			root->right = f((start+end)/2,end,ar,new Node);
			root->max = max(root->left->max,root->right->max);
			root->min = min(root->left->min,root->right->min);
		}
		return root;
	}
	int Tree::getmin(int a,int b,Node *root = NULL)
	{
		if(root==NULL)
			root = _root;
		if(root->a==a&&root->b==b)
			return root->min;
		if(b<=(root->a+root->b)/2)
			return getmin(a,b,root->left);
		else if(a>=(root->a+root->b)/2)
			return getmin(a,b,root->right);
		else
			return min(getmin(a,(a+b)/2),getmin((a+b)/2,b));
	}
	
	int Tree::getmax(int a,int b,Node *root = NULL)
	{
		if(root==NULL)
			root = _root;
		if(root->a==a&&root->b==b)
			return root->max;
		if(b<=(root->a+root->b)/2)
			return getmax(a,b,root->left);
		else if(a>=(root->a+root->b)/2)
			return getmax(a,b,root->right);
		else
			return max(getmax(a,(a+b)/2),getmax((a+b)/2,b));
	}
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	int n,m;
	cin>>n>>m;
	int *a = new int[n+1];
	for(int i=1;i<=n;i++)
		cin>>a[i];
	Tree tree(a,n);
	for(int i=0;i<m;i++)
	{
		string cmd;
		cin>>cmd;
		int x,y;
		cin>>x>>y;
		if(cmd=="max")
		{
			cout<<abs(tree.getmax(x,y)-tree.getmin(x,y))<<endl;
		}
		if(cmd=="min")
		{
			cout<<tree.getmin(x,y)<<endl;
		}
	}
}
