#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#define maxn 1001000
#define INF 2147483647
using namespace std;
int N,n,m;
int a[maxn],b[maxn];
struct tree
{
	int left,right,Max,Min,nbmin;
}t[4*maxn];
int Abs(int x)
{
	if (x>0)return x;
	else return -x;
}
void build_tree()
{
	int len=1;
	while (len<N)
		len*=2;
	for (int i=len;i<len+N;i++)
	{
		t[i].left=t[i].right=i-len+1;
		t[i].Max=t[i].Min=a[i-len+1];
		t[i].nbmin=INF;
	}
	for (int i=len+N;i<len*2;i++)
	{
		t[i].left=t[i].right=i-len+1;
		t[i].Max=-INF;
		t[i].Min=INF;
		t[i].nbmin=INF;
	}
	for (int i=len-1;i>=1;i--)
	{
		t[i].left=t[i*2].left;
		t[i].right=t[i*2+1].right;
		t[i].Max=max(t[i*2].Max,t[i*2+1].Max);
		t[i].Min=min(t[i*2].Min,t[i*2+1].Min);
		if (t[i*2+1].left<=N)
			t[i].nbmin=min(Abs(a[t[i*2].right]-a[t[i*2+1].left]),min(t[i*2].nbmin,t[i*2+1].nbmin));
		else t[i].nbmin=INF;
	}
}
int query_max(int id,int left,int right)
{
	if (t[id].left==left&&t[id].right==right)
	{
		return t[id].Max;
	}
	if (t[id*2].right>=right)
		return query_max(id*2,left,right);
	else if (t[id*2+1].left<=left)
		return query_max(id*2+1,left,right);
	else 
		return max(query_max(id*2,left,t[id*2].right),query_max(id*2+1,t[id*2+1].left,right));
}
int query_min(int id,int left,int right)
{
	if (t[id].left==left&&t[id].right==right)
	{
		return t[id].Min;
	}
	if (t[id*2].right>=right)
		return query_min(id*2,left,right);
	else if (t[id*2+1].left<=left)
		return query_min(id*2+1,left,right);
	else 
		return min(query_min(id*2,left,t[id*2].right),query_min(id*2+1,t[id*2+1].left,right));
}
int query_nbmin(int id,int left,int right)
{
	if (t[id].left==left&&t[id].right==right)
	{
		return t[id].nbmin;
	}
	if (t[id*2].right>=right)
		return query_nbmin(id*2,left,right);
	else if (t[id*2+1].left<=left)
		return query_nbmin(id*2+1,left,right);
	else 
	{
		return min(Abs(a[t[id*2].right]-a[t[id*2+1].left]),min(query_nbmin(id*2,left,t[id*2].right),query_nbmin(id*2+1,t[id*2+1].left,right)));
	}
}
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	char s[10];
	int x,y;
	scanf("%d%d",&n,&m);
	memset(a,INF,sizeof(a));
	for (int i=1;i<=n;i++)
		scanf("%d",&a[i]);
	N=n;
	for (int i=1;i<=m;i++)
	{			
		cin>>s;
		scanf("%d%d",&x,&y);
		if (n<=1000)
		{
			if (s[0]=='i')
			{
				N++;
				b[x+1]=y;
				for (int j=1;j<=x;j++)
					b[j]=a[j];
				for (int j=x+2;j<=N;j++)
					b[j]=a[j-1];
				for (int j=1;j<=N;j++)
					a[j]=b[j];
			}
			else if (s[1]=='e')
			{
				N--;
				b[x]=y;
				for (int j=1;j<=x-1;j++)
					b[j]=a[j];
				for (int j=x+1;j<=N;j++)
					b[j]=a[j+1];
				for (int j=1;j<=N;j++)
					a[j]=b[j];
			}		
		}
		build_tree();
	
		if (s[1]=='a')
			printf("%d\n",query_max(1,x,y)-query_min(1,x,y));
		else if (s[1]=='i')
			printf("%d\n",query_nbmin(1,x,y));
	}
	//system("pause");
	return 0;
}
