#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <queue>
#include <map>

using namespace std;

const int MAXN = 16 + 4;
const int MAXM = 120 + 10;

int n, m;

namespace Case1
{
//	struct Edge
//	{
//		int next, to;	
//	}
//	e[2 * MAXM];
//	int p[MAXN], l = 2;
//	void addE(int a, int b)
//	{
//		e[l].next = p[a];
//		e[l].to = b;
//		p[a] = l++;	
//	}
	int r[MAXN], val[MAXN], dfn[MAXN], id[MAXN], totw = 0;
	pair<int, int> edge[MAXM];
	void dfs(int x)
	{
		++totw;
		dfn[x] = totw, id[totw] = x;
		for(int i = 1; i <= n; i++)
			if(r[i] == x)
				dfs(i);
	}
	
	queue<int> q;
	map<int, int> f;
	
	int calc(int *s)
	{
		int ret = 0;
		for(int i = 1; i <= n; i++)
			ret = ret * (n + 1) + s[i];	
		return ret;
	}
	
	void add(int a, int b)
	{
		if(f.find(a) == f.end())
		{
			f[a] = b;
			q.push(a);
		}
	}
	
	void expand(int a)
	{
		static int s[MAXN];
		int cnt = f[a];
		for(int i = n; i >= 1; i--)
			s[i] = a % (n + 1), a /= (n + 1);
//		for(int i = 1; i <= n; i++)
//			cout << s[i] << ' ';
//		cout << endl;
		
		bool ok = true;
		for(int i = n; i >= 1; i--)
		{
			int x = id[i];
			if(r[x] && f[s[x]]> f[s[r[x]]])
			{
				ok = false;
				break;	
			}
		}
		if(ok)
		{
			cout << cnt << endl;
			exit(0);	
		}
//		cout << cnt << endl;
		
		for(int i = 1; i <= m; i++)
		{
			int x = edge[i].first, y = edge[i].second;
			swap(s[x], s[y]);
			add(calc(s), cnt + 1);
		}
	}
	
	void solve()
	{
		int tmp = 0;
		for(int i = 1; i <= n; i++)
			tmp = tmp * (n + 1) + i;
		add(tmp, 0);
		while(!q.empty())
		{
			int x = q.front();
//			cout << x << endl;
			q.pop();
			expand(x);
		}
	}
	
	void work()
	{
		for(int i = 1; i <= n; i++)
			cin >> r[i];
		for(int i = 1; i <= n; i++)
			if(r[i] == 0)
				dfs(i);
		for(int i = 1; i <= n; i++)
			cin >> f[i];
		for(int i = 1; i <= m; i++)
		{
			cin >> edge[i].first >> edge[i].second;
//			addE(x, y), addE(y, x);	
		}
		solve();
	}
}

int main()
{
	ios::sync_with_stdio(false);
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	
	cin >> n >> m;
	Case1::work();
	

	return 0;
}
/*
4 4
0 1 2 3
1 2 3 4
1 2
1 4
2 3
1 3
*/
/*
5 4
3 3 5 5 0
4 8 10 9 3
1 2
2 4
1 3
4 5
*/

