//#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
int n, m;
int s, t;
char in[10];
int a[200100];
int c[200100];
int st_max[200100][20];
int st_min[200100][20];
int stc_min[200100][20];
int abs(int x)
{
	if(x < 0)
		return -x;
	else
		return x;
}
void initial()
{
	memset(st_min, 63, sizeof(st_min));
	memset(stc_min, 63, sizeof(stc_min));
	for(int i = 1; i <= n; i++)
	{
		scanf("%d", &a[i]);
		c[i - 1] = abs(a[i] - a[i - 1]);
		st_max[i][0] = a[i];
		st_min[i][0] = a[i];
		stc_min[i - 1][0] = c[i - 1];
	}
	int temp;
	for(int i = 1; i < 19; i++)
	{
		temp = 1 << (i - 1);
		for(int j = 1; j <= n; j++)
		{
			st_max[j][i] = max(st_max[j + temp][i - 1], st_max[j][i - 1]);
			st_min[j][i] = min(st_min[j + temp][i - 1], st_min[j][i - 1]);
			stc_min[j][i] = min(stc_min[j + temp][i - 1], stc_min[j][i - 1]);
		}
	}
}
int log(int x)
{
	int count = 0;
	while(x)
	{
		x >>= 1;
		count++;
	}
	return count - 1;
}
int main()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	scanf("%d%d", &n, &m);
	initial();
	int ans, ll, mx, mn;
	if(n <= 1000)
	{
		for(int i = 0; i < m; i++)
		{
			scanf("%s", &in);
			scanf("%d%d", &s, &t);
			if(in[1] == 'a')
			{
				mx = 0;
				mn = 2147483647;
				for(int j = s; j <= t; j++)
				{
					mx = max(mx, a[j]);
					mn = min(mn, a[j]);
				}
				ans = mx - mn;
				printf("%d\n", ans);
			}
			else if(in[1] == 'i')
			{
				mn = 2147483647;
				for(int j = s; j < t; j++)
				{
					mn = min(mn, abs(a[j + 1] - a[j]));
				}
				printf("%d\n", mn);
			}
			else if(in[1] == 'e')
			{
				a[s] = t;
				for(int j = s + 1; j <= n; j++)
				{
					a[j] = a[j + 1];
				}
				n--;
			}
			else if(in[1] == 'n')
			{
				for(int j = n; j >= s + 1; j--)
				{
					a[j + 1] = a[j];
				}
				a[s + 1] = t;
				n++;
			}
		}
	}
	else
	{
		for(int i = 0; i < m; i++)
		{
			scanf("%s", &in);
			scanf("%d%d", &s, &t);
			if(in[1] == 'a')
			{
				ll = log(t - s + 1);
				mx = max(st_max[s][ll], st_max[t - (1 << ll) + 1][ll]);
				mn = min(st_min[s][ll], st_min[t - (1 << ll) + 1][ll]);
				ans = mx - mn;
				printf("%d\n", ans);
			}
			if(in[1] == 'i')
			{
				ll = log(t - s);
				mn = min(stc_min[s][ll], stc_min[t - (1 << ll)][ll]);
				printf("%d\n", mn);
			}
		}
	}
	return 0;
}
