#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<algorithm>
using namespace std;
int abs1(int x)
{
	if(x>=0)
		return x;
	return -x;
}
int e[101010];
struct Node
{
	int l,r;
	Node *lch,*rch;
	int ln,rn,ma,mi,mii;
};
Node *root;
Node *Build1(int l,int r)
{
	Node *ret=new Node;
	ret->l=l;
	ret->r=r;
	ret->ln=e[l];
	ret->rn=e[r];
	if(l==r)
	{
		ret->ma=ret->mi=e[l];
		ret->mii=2147483647;
		ret->lch=ret->rch=NULL;
		return ret;
	}
	int mid=(l+r)/2;
	ret->lch=Build1(l,mid);
	ret->rch=Build1(mid+1,r);
	ret->ma=max(ret->lch->ma,ret->rch->ma);
	ret->mi=min(ret->lch->mi,ret->rch->mi);
	ret->mii=min(ret->lch->mii,ret->rch->mii);
	ret->mii=min(ret->mii,abs1(ret->rch->ln-ret->lch->rn));
	return ret;
}
int max1,min1;
void find1(Node *root1,int l,int r)
{
	if(l<=root1->l&&r>=root1->r)
	{
		max1=max(max1,root1->ma);
		min1=min(min1,root1->mi);
		return ;
	}
	int mid=(root1->l+root1->r)/2;
	if(l<=mid)
		find1(root1->lch,l,r);
	if(r>mid)
		find1(root1->rch,l,r);
}
int find2(Node *root1,int l,int r)
{
	int ret=2147483647;
	if(l<=root1->l&&r>=root1->r)
	{
		ret=min(root1->mii,ret);
		return ret;
	}
	int mid=(root1->l+root1->r)/2;
	if(l<=mid)
		ret=min(ret,find2(root1->lch,l,r));
	if(r>mid)
		ret=min(ret,find2(root1->rch,l,r));
	if(l<=mid&&r>mid)
		ret=min(ret,abs1(root1->rch->ln-root1->lch->rn));
	return ret;
}
int main()
{
	int n,m;
	char s[10];
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++)
		scanf("%d",&e[i]);
	int x,y;
	int mi,ma,ans;
	if(n<=1000&&m<=1000)
	{
		for(int i=1;i<=m;i++)
		{
			scanf("%s",s);
			scanf("%d%d",&x,&y);
			if(s[1]=='e')
			{
				e[x]=y;
				for(int j=x+1;j<n;j++)
					e[j]=e[j+1];
				n--;
			}
			else if(s[1]=='n')
			{
				for(int j=n+1;j>x+1;j--)
					e[j]=e[j-1];
				e[x+1]=y;
				n++;
			}
			else if(s[1]=='a')
			{
				mi=2147483647;
				ma=0;
				for(int j=x;j<=y;j++)
				{
					ma=max(ma,e[j]);
					mi=min(mi,e[j]);
				}
				printf("%d\n",ma-mi);
			}
			else
			{
				ans=2147483647;
				for(int j=x+1;j<=y;j++)
					ans=min(ans,abs1(e[j]-e[j-1]));
				printf("%d\n",ans);
			}
		}
	}
	else
	{
		root=Build1(1,n);
		for(int i=1;i<=m;i++)
		{
			scanf("%s",s);
			scanf("%d%d",&x,&y);
			if(s[1]=='a')
			{
				min1=2147483647;
				max1=0;
				find1(root,x,y);
				printf("%d\n",max1-min1);
			}
			else
				printf("%d\n",find2(root,x,y));
		}
	}
	return 0;
}
