#include <bits/stdc++.h>
#define Rep(i,n) for(int i = 1;i <= n;++ i)
using namespace std;

typedef long long LL;
const int N = 300005;
int n,K,val[N * 2],tou[22],wei[22],q[405][22];
LL f[405][22],V,sum[N * 2];
LL sqr(LL a){return a * a;}
LL calc(LL a,LL b){return sqr(a) + sqr(b);}
LL cal(int st,int ed,int k){return abs((sum[k] - sum[st - 1]) - (sum[ed] - sum[k]));}
int San(int st,int ed)
{
	int l = st,r = ed;
	int m1,m2;
	while(r - l >= 2)
	{
		m1 = (l + r) >> 1;
		m2 = (m1 + r) >> 1;
		if(cal(st,ed,m1) < cal(st,ed,m2))r = m2;
		else l = m1;
	}
	int z = l;
	for(int i = l;i <= r;++ i)if(cal(st,ed,z) > cal(st,ed,i))z = i;
	return z;
}
LL solve(int st,int ed)
{
	LL re = (1ll << 62) - 5;
	for(int i = st;i < ed;++ i)
	{
		for(int j = i + 1;j < ed;++ j)
		{
			//[st,i][i + 1,j][j + 1,ed]
			re = min(re,sqr(sum[i] - sum[st - 1]) + sqr(sum[j] - sum[i]) + sqr(sum[ed] - sum[j]));
		}
	}
	return re;
}
LL solve2(int st,int ed)
{
	Rep(i,n)for(int j = 1;j <= K;++ j)f[i][j] = 0;
	Rep(i,n)
	{
		f[i][1] = sqr(sum[st + i - 1] - sum[st - 1]);
		for(int j = 2;j <= K;++ j)
		{
			f[i][j] = (1ll << 62) - 5;
			for(int k = 1;k < i;++ k)
				f[i][j] = min(f[k][j - 1] + sqr(sum[i + st - 1] - sum[st + k - 1]),f[i][j]);
		}
	}
	return f[n][K];
}
struct Point{LL x,y;}g[405][22];
LL get(int j,int id,LL sl){return g[id][j].y - g[id][j].x * sl;}
LL cross(Point a,Point b){return a.x * b.y - a.y * b.x;}
int sol(int st,int i,int j,LL sl)
{
	j --;
	while(tou[j] < wei[j] && get(j,q[tou[j] + 1][j],sl) <= get(j,q[tou[j]][j],sl))tou[j] ++;
	return q[tou[j]][j];
}
void Add(int i,int j,LL X,LL Y)
{
	Point p = (Point){X,Y};
	#define tt q[wei[j]][j]
	while(tou[j] < wei[j] && cross(g[tt][j],p) < 0)wei[j] --;
	q[++ wei[j]][j] = i;g[wei[j]][j] = p;
}
LL solve3(int st,int ed)
{
	for(int i = 0;i <= n;++ i)
		for(int j = 1;j <= K;++ j)f[i][j] = 0,g[i][j].x = g[i][j].y = 0,q[i][j] = 0;
	for(int i = 1;i <= K;++ i)tou[i] = 1,wei[i] = 0;
	for(int i = 1;i <= n;++ i)
	{
		for(int j = 2;j <= K;++ j)
		{
			int k = sol(st,i,j,2 * sum[st + i - 1]); //б 
			f[i][j] = f[k][j - 1] + sqr(sum[i + st - 1] - sum[st + k - 1]);
			Add(i,j,sum[st + i - 1],f[i][j] + sqr(sum[i + st - 1]));
		}
		f[i][1] = sqr(sum[st + i - 1] - sum[st - 1]);
		Add(i,1,sum[st + i - 1],f[i][1] + sqr(sum[i + st - 1]));
	}
	return f[n][K];
}
int main()
{
	//freopen("spaceship.in","r",stdin);
	//freopen("spaceship.out","w",stdout);
	scanf("%d%d",&n,&K);
	Rep(i,n)scanf("%d",&val[i]),V += val[i],val[i] *= K;
	Rep(i,n - 1)val[i + n] = val[i];
	Rep(i,2 * n - 1)sum[i] = sum[i - 1] + val[i];
	if(K == 2)
	{
		LL ans = 1ll << 62;
		Rep(i,n)//[i,i + n - 1]
		{
			int id = San(i,i + n - 1);
			ans = min(ans,calc(sum[id] - sum[i - 1],sum[i + n - 1] - sum[id]));
		}
		ans -= V * V * K;
		printf("%lld\n",ans);
	}
	else if(K == 3)
	{
		LL ans = 1ll << 62;
		Rep(i,n)ans = min(ans,solve(i,i + n - 1));
		ans -= V * V * K;
		printf("%lld\n",ans);
	}
	else if(K == 6 || K == 7 || K == 10)
	{
		LL ans = 1ll << 62;
		Rep(i,n)ans = min(ans,solve2(i,i + n - 1));
		ans -= V * V * K;
		printf("%lld\n",ans);
	}
	else 
	{
		LL ans = 1ll << 62;
		Rep(i,n)ans = min(ans,solve3(i,i + n - 1));
		ans -= V * V * K;
		printf("%lld\n",ans);
	}
	return 0;
}
/*
5 2
4 2 6 1 3

5 3
4 2 6 1 3

*/
