#include <bits/stdc++.h>
#define Rep(i,n) for(int i = 1;i <= n;++ i)
using namespace std;

typedef long long LL;
const int N = 300005;
int n,K,val[N * 2];
LL f[405][22],V,g[405][22];
LL sum[N * 2];
LL sqr(LL a){return a * a;}
LL calc(LL a,LL b){return sqr(a) + sqr(b);}
LL cal(int st,int ed,int k){return abs((sum[k] - sum[st - 1]) - (sum[ed] - sum[k]));}
int San(int st,int ed)
{
	int l = st,r = ed;
	int m1,m2;
	while(r - l >= 2)
	{
		m1 = (l + r) >> 1;
		m2 = (m1 + r) >> 1;
		if(cal(st,ed,m1) < cal(st,ed,m2))r = m2;
		else l = m1;
	}
	int z = l;
	for(int i = l;i <= r;++ i)if(cal(st,ed,z) > cal(st,ed,i))z = i;
	return z;
}
LL solve(int st,int ed)
{
	LL re = (1ll << 62) - 5;
	for(int i = st;i < ed;++ i)
	{
		for(int j = i + 1;j < ed;++ j)
		{
			//[st,i][i + 1,j][j + 1,ed]
			re = min(re,sqr(sum[i] - sum[st - 1]) + sqr(sum[j] - sum[i]) + sqr(sum[ed] - sum[j]));
		}
	}
	return re;
}
LL solve2(int st,int ed)
{
	Rep(i,n)for(int j = 1;j <= K;++ j)f[i][j] = 0;
	Rep(i,n)
	{
		f[i][1] = sqr(sum[st + i - 1] - sum[st - 1]);
		for(int j = 2;j <= K;++ j)
		{
			f[i][j] = (1ll << 62) - 5;
			int id = 0;
			for(int k = 1;k < i;++ k)
			{
				LL z = f[i][j];
				f[i][j] = min(f[k][j - 1] + sqr(sum[i + st - 1] - sum[st + k - 1]),f[i][j]);
				if(f[i][j] < z)id = k;
			}
		}
	}
	return f[n][K];
}
LL solve3(int st,int ed)
{
	for(int i = 0;i <= n;++ i)
		for(int j = 1;j <= K;++ j)f[i][j] = 0,g[i][j] = (1ll << 62) - 5;
	Rep(i,n)
	{
		f[i][1] = sqr(sum[st + i - 1] - sum[st - 1]);
		g[i][1] = f[i][1] - sum[i + st - 1];
		for(int j = K;j >= 2;-- j)
		{
			f[i][j] = g[i - 1][j - 1] + sum[i + st - 1];
			g[i][j] = min(f[i][j] - sum[i + st - 1],g[i - 1][j]);
		}
	}
	return f[n][K];
}
int main()
{
	freopen("spaceship.in","r",stdin);
	freopen("ship.out","w",stdout);
	scanf("%d%d",&n,&K);
	Rep(i,n)scanf("%d",&val[i]),V += val[i],val[i] *= K;
	Rep(i,n - 1)val[i + n] = val[i];
	Rep(i,2 * n - 1)sum[i] = sum[i - 1] + val[i];
	LL ans = 1ll << 62;
	Rep(i,n)ans = min(ans,solve2(i,i + n - 1));
	ans -= V * V * K;
	printf("%lld\n",ans);
	return 0;
}
/*
7 3 
8 9 4 5 6 1 3

*/
/*
point(s[k],s[k] ^ 2 + f[k])
slope(2s[i])
s[k] ^ 2 + f[k] = 2s[i]s[k] + b;

b = s[k] ^ 2 + f[k] - 2s[i]s[k];
so : min{b} = min{s[k] ^ 2 + f[k] - 2s[i]s[k]};
*/
