#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<climits>
#include<cmath>
#include<cstring>
#include<algorithm>
#define MAXN 100050

using namespace std;

int A[MAXN],siz;
int n,m;
char opt[20],x,y;
int top;
int Maxx=0,Minx=INT_MAX;

struct Node
{
	int Min,Max,left,right;
	Node *lson,*rson;
}pool[MAXN*10],*root,*root1;

void Build(Node *p,int left,int right,bool flag)
{
	p->left=left;
	p->right=right;
	if(left==right && flag==0)
	{
		p->Min=A[left];
		p->Max=A[left];
		return ;
	}
	if(left==right && flag==1)
	{
		p->Min=abs(A[left+1]-A[left]);
		p->Max=abs(A[left+1]-A[left]);
		return ;
	}
	int mid=(left+right)/2;
	p->lson=&pool[++top];
	p->rson=&pool[++top];
	Build(p->lson,left,mid,flag);
	Build(p->rson,mid+1,right,flag);
	p->Min=min(p->lson->Min,p->rson->Min);
	p->Max=max(p->lson->Max,p->rson->Max);
}

void Query(Node *p,int left,int right)
{
	if(p->left==left && p->right==right)
	{
		Minx=min(p->Min,Minx);
		Maxx=max(p->Max,Maxx);
		return ;
	}
	if(p->lson->right>=right)
		Query(p->lson,left,right);
	else if(p->rson->left<=left)
		Query(p->rson,left,right);
	else
	{
		Query(p->lson,left,p->lson->right);
		Query(p->rson,p->rson->left,right);
	}
}

int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	cin>>n>>m;
	siz=n;
	if(n<=1010 && m<=1010)
	{
		for(int i=1;i<=siz;i++)
			scanf("%d",&A[i]);
		for(int i=1;i<=m;i++)
		{
			scanf("%s",opt);
			scanf("%d%d",&x,&y);
			if(opt[1]=='n')
			{
				for(int j=siz;j>x;j--)
					A[j+1]=A[j];
				siz++;
				A[x]=y;
			}
			if(opt[1]=='e')
			{
				for(int j=x+2;j<=siz;j++)
					A[j-1]=A[j];
				siz--;
				A[x]=y;
			}
			if(opt[1]=='a')
			{
				Maxx=0;Minx=INT_MAX;
				for(int i=x;i<=y;i++)
				{
					Maxx=max(Maxx,A[i]);
					Minx=min(Minx,A[i]);
				}
				printf("%d\n",Maxx-Minx);
			}
			if(opt[1]=='i')
			{
				Minx=INT_MAX;
				for(int i=x+1;i<=y;i++)
					Minx=min(Minx,A[i]-A[i-1]);
				printf("%d\n",Minx);
			}
		}
		return 0;
	}
	else
	{
		root=&pool[++top];
		root1=&pool[++top];
		for(int i=1;i<=n;i++)
			scanf("%d",&A[i]);
		Build(root,1,n,0);
		Build(root1,1,n-1,1);
		for(int i=1;i<=m;i++)
		{
			scanf("%s",opt);
			scanf("%d%d",&x,&y);
			if(opt[1]=='a')
			{
				Minx=INT_MAX;
				Maxx=0;
				Query(root,x,y);
				printf("%d\n",Maxx-Minx);
			}
			else
			{
				Minx=INT_MAX;
				Maxx=0;
				Query(root1,x,y-1);
				printf("%d\n",Minx);
			}
		}
	}
	return 0;
}
