#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>

using namespace std;

int n, k;
int sum = 0;
double avg;
int l[300010] = {0}, w[300010];

long long ans = 9223372036854775807;
long long tmp = 0;
int pre;
void dfs(int p, int cut) {
	//cerr << p << " " << cut << endl;
	//cerr << tmp << endl;
	int cnt = 0, p1;
	for(int i = p; i <= n; ++i)
	{
		cnt += l[i];
		if(cnt * k >= sum)
		{
			cnt = abs(cnt * k - sum) < abs((cnt - l[i]) * k - sum) ? cnt : cnt - l[i];
			p1 = abs(cnt * k - sum) < abs((cnt - l[i]) * k - sum) ? i : i - 1;
			if(cnt == 0)
			{
				cnt += l[i];
				p1 = i;
			}
			tmp += (long long)abs(cnt * k - sum) * abs(cnt * k - sum);
			dfs(p1 + 1, cut + 1);
			return;
		}
	}
	if(cut == k - 1)
	{
		tmp += (long long)((w[n] - w[p - 1] + pre) * k - sum) * ((w[n] - w[p - 1] + pre) * k - sum);
		ans = min(ans, tmp);
	}
}

int main()
{
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	ios::sync_with_stdio(false);
	
	cin >> n >> k;
	for(int i = 1; i <= n; ++i)
	{
		cin >> l[i];
		sum += l[i];
		w[i] = w[i - 1] + l[i];
	}
	pre = 0;
	for(int i = 1; i + k <= n + 1; ++i)
	{
		tmp = 0;
		pre += l[i - 1];
		dfs(i, 0);
	}
	cout << ans << endl;		
	
	return 0;
}

