#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <queue>
#include <vector>

using namespace std;

typedef long long LL;
const int N = 300000 + 5;
LL INF = 1e18;

int n, k, L[N << 1], sum[N << 1];

void init()
{
	scanf("%d%d", &n, &k);
	for (int i = 1; i <= n; i ++)
		scanf("%d", &L[i]), L[n + i] = L[i];
	for (int i = 1; i <= 2 * n; i ++)
		sum[i] = sum[i - 1] + L[i];
}

LL val(int l, int r)
{
	return 1ll*(sum[r]-sum[l-1])*(sum[r]-sum[l-1])*k*k-(sum[r]-sum[l-1]<<1)*sum[n]*k;
}

void baoli2()
{
	//printf("%d %d\n", val(3, 5) + val(6, 7));
	LL ans = INF;
	for (int i = 1; i <= n; i ++){
		int l = i, r = n + i - 1;
		//printf("%d:\n", i);
		while (l+1 < r){
			int mid = (l + r) >> 1, mid2 = (mid + r) >> 1;
			LL smid = val(i, mid) + val(mid+1, n+i-1);
			LL smid2 = val(i, mid2) + val(mid2+1, n+i-1);
			if (smid < smid2) r = mid2;
			else l = mid;
		}
		LL s = val(i, l) + val(l+1, n+i-1), s1 = val(i, r) + val(r+1, n+i-1);
		if (s > s1) s = s1;
		if (ans > s) ans = s;
		//printf("%lld %lld %lld\n", s, s1, ans);
	}
	printf("%lld\n", ans + sum[n]*sum[n]*k);
}

void baoli3()
{
	int mid = 1, mid2 = 1; LL ans = INF;
	for (int i = 1; i <= n; i ++){
		while ((sum[mid]-sum[i-1])*k<sum[n]) mid ++;
		while ((sum[mid2]-sum[mid])*k<sum[n]) mid2 ++;
		LL s = val(i, mid) + val(mid+1, mid2) + val(mid2+1, n+i-1), s1;
		while(1){
			s1 = val(i, mid) + val(mid+1, mid2-1) + val(mid2, n+i-1);
			while(s1 < s && mid2 > mid){
				s = s1;
				mid2 --;
				s1 = val(i, mid) + val(mid+1, mid2-1) + val(mid2, n+i-1);
			}
			s1 = val(i, mid-1) + val(mid, mid2) + val(mid2+1, n+i-1);
			if (s1 >= s || mid <= i || mid2 <= mid) break;
			s = s1;
			mid --;
		}
		//printf("%lld %lld %lld\n", val(1, 2), val(3, 3), val(4, 5));
		if (s < ans) ans = s;
	}
	
	printf("%lld\n", ans + sum[n]*sum[n]*k);
}

LL f[205][205][15];

void baoli()
{
	memset(f, 0x7f, sizeof(f));
	for (int i = 1; i <= n; i ++)
		f[i][0][0] = 0, f[i][0][1] = val(i, i);
	for (int i = 1; i <= n; i ++)
		for (int j = 1; j <= n; j ++)
			for (int l = 1; l <= k; l ++)
				for (int p = 0; p < j; p ++)
				if (f[i][p][l-1] + val(i+p, i+j-1)< f[i][j][l])
					f[i][j][l] = f[i][p][l-1] + val(i+p, i+j-1);
	LL ans = INF;
	for (int i = 1; i <= n; i ++)
		if (f[i][n][k] < ans) ans = f[i][n][k];
	printf("%lld\n", ans + sum[n]*sum[n]*k);
}

int main()
{
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	init();
	if (k == 2) baoli2();
	else if (k < 300)baoli();
	else if (k == 3) baoli3();
	else puts("0");
	return 0;
}
/*
5 2
4 2 6 1 3 

5 3
4 2 6 1 3 
*/
