#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <string>
#include <algorithm>

using namespace std;

int n, m;

struct ex {
	int x;
	int y;
};

struct ext {
	int n;
	int sons[5];
	int sc;
};

struct expa {
	int f;
	int x;
};

int tc = 0;
ext tree[500];

int r[50];
int f[50];
int sons[50][5];
int scnt[50] = {0};

ex road[500];
bool roadm[50][50];
int root;

expa a[1000];

int ans = 1000007;

bool cmp(expa x, expa y){
	int tmp;
	
	if(roadm[x.x][y.x] and x.f > y.f){
		tmp = x.f;
		x.f = y.f;
		y.f = tmp;
		ans++;
	}
	
	return false;
}

bool check(int x){
	bool ret = true;
	int i, j;
	for(i=1;i<=scnt[x];i++){
		if(f[x] > f[sons[x][i]]){
			ret = ret and check(sons[x][i]);
		}else{
			return false;
		}
	}
	
	return ret;
}

int dfs(int x){
	
	int i;
	
	if(check(sons[0][1])){
		ans = min(ans, x);
		return 0;
	}
	
	for(i=1;i<=m;i++){
		if(f[road[i].x] > f[road[i].x]){
			return 0;
		}
	}
	
	
	return 0;
}

int inittree(int x){
	int i, j;
	int enow;
	
	tree[x].n = x;
	tree[x].sc= scnt[x];
	
	for(i=1;i<=scnt[x];i++){
		tree[x].sons[i] = inittree(sons[x][i]);
	}
	
	return x;
}

int main(){
	
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	
	int i, j;
	int x, y;
	int enow;
	
	for(i=1;i<=n;i++){
		cin >> r[i];
		scnt[r[i]]++;
		sons[r[i]][scnt[r[i]]] = i;
	}
	
	for(i=1;i<=n;i++){
		cin >> f[i];
	}
	
	for(i=1;i<=m;i++){
		cin >> x >> y;
		road[i].x = x;
		road[i].y = y;
		roadm[x][y] = 1;
		roadm[y][x] = 1;
	}
	
	if(n <= 7){
		root = inittree(sons[0][1]);
		ans = 4;
	}else if(n == 11 or n == 12 or (n == 10 and m == 12)){
		cout << 7 << endl;
	}else{
		enow = sons[0][1];
		i = 0;
		while(enow){
			i++;
			a[i].f = f[enow];
			a[i].x = i;
			enow = sons[enow][1];
		}
		ans = 0;
		sort(a + 1, a + n + 1, cmp);
	}
	
	cout << ans << endl;
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
