#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<iostream>
#include<algorithm>
#include<queue>
#include<ctime>
using namespace std;
#define rep(i,a,b) for(int i=a;i<=b;i++)
#define dow(i,a,b) for(int i=a;i>=b;i--)
#define tab(i,u) for(int i=head[u];i!=-1;i=e[i].next)
#define cls(a,x) memset(a,x,sizeof(a))
const int INF = 0x3f3f3f3f;
const int N = 15, M = 25;
int n,m;
int fa[N],rt,head[N],e_tot;
struct Edge {
	int ed,next;
} e[N*N*2];
void init() {
	e_tot=0;
	cls(head,-1);
}
void add(int u,int v) {
	e[e_tot].ed=v;
	e[e_tot].next=head[u];
	head[u]=e_tot++;
}
int dep[N];
void dfs(int u) {
	dep[u] = dep[fa[u]]+1;
	tab(i,u) {
		int v=e[i].ed;
		if(v==fa[u]) continue;
		dfs(v);	
	}
}
int a[N],b[N],g[N][N],x[M],y[M];
bool ok() {
	rep(i,1,n) if(i!=rt && b[i]>b[fa[i]]) return false;
	return true;
}
void solve1() {
	int ans=0;
	while(!ok()) {
		rep(i,1,n) cout<<b[i]<<' ';
		cout<<endl;
		int x0,y0;
		rep(i,1,m) {
			x0=x[i],y0=y[i];
			if(b[x0]<b[y0] && dep[x0]<dep[y0]) {
				swap(b[x0],b[y0]);
				ans++;
			}
			else if(b[x0]>b[y0] && dep[x0]>dep[y0]) {
				swap(b[x0],b[y0]);
				ans++;
			}
		}
	}
	printf("%d\n",ans);
}
int cal2() {
	rep(i,1,n) b[i]=a[i];
	rep(k,1,n)
		rep(i,1,n)
			rep(j,1,n) {
				g[i][j]=min(g[i][j],g[i][k]+g[k][j]);
			}
	int ans=0;
	int x0,y0;
	int cnt=0;
	while(!ok()) {
		x0=1 + rand()%n;
		y0=1 + rand()%n;
		if(x0==y0) continue;
		if(b[x0]<b[y0] && dep[x0]<dep[y0]) {
			swap(b[x0],b[y0]);
			ans+=g[x0][y0];
		}
		else if(b[x0]>b[y0] && dep[x0]>dep[y0]) {
			swap(b[x0],b[y0]);
			ans+=g[x0][y0];
		}
		cnt++;
		if(cnt>10000) break;
	}
	return ans;
}
void solve2() {
	srand(time(0));
	int ans=INF;
	rep(T,1,100) {
		ans=min(ans,cal2());
	}
	printf("%d\n",ans);
}
int main() {
	freopen("interstellar.in","r",stdin);
	freopen("interstellar.out","w",stdout);
	scanf("%d%d",&n,&m);
	init();
	rep(i,1,n) {
		scanf("%d",&fa[i]);
		if(fa[i]==0) {
			rt=i;
		}
		else {
			add(fa[i],i);
			add(i,fa[i]);
		}
	}
	dep[0]=0;
	dfs(rt);
	rep(i,1,n) scanf("%d",&a[i]);
	cls(g,0x3f);
	rep(i,1,n) {
		scanf("%d%d",&x[i],&y[i]);
		g[x[i]][y[i]]=g[y[i]][x[i]]=1;
	}
	solve2();
	return 0;	
}

