#include <ctime>
#include <cstdlib>
#include <cstring>
#include <fstream>
using namespace std;
ifstream cin("spaceship.in");
ofstream cout("spaceship.out");
typedef long long LL;
const LL oo = 1e18;
size_t n, K;
LL sumofs, arr[601010], pl[601010], dp[850][850][30], ans = oo;

template<typename T>
inline T sqr(const T &a)
{ return a * a; }

LL memdp(const size_t &front, const size_t &back, const size_t &slice)
{
	LL &sav = dp[front][back][slice];
	if (sav != -1) return sav;
	if (slice == 1) return sav = sqr(K * (pl[back] - pl[front]) - sumofs);
	sav = oo;
	for (size_t i = 1; i < slice; ++i)
		for (size_t j = front + 1; j <= back; ++j)
		{
			if (j - front < i || back - j < slice - i) continue;
			sav = min(sav, memdp(front, j, i) + memdp(j, back, slice - i));
		}
	return sav;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cin >> n >> K;
	for (size_t i = 1; i <= n; ++i)
	{
		cin >> arr[i];
		sumofs += arr[i];
		arr[i + n] = arr[i];
	}
	for (size_t i = 1; i < n * 2; ++i)
		pl[i] = pl[i - 1] + arr[i];
	if (n <= 500)
	{
		const size_t &up = n * 2;
		memset(dp, -1, sizeof dp);
		for (size_t i = 0; i < n; ++i)
			ans = min(ans, memdp(i, i + n, K));
	}
	else
	{
		if (K == 2)
			for (size_t i = 0; i < n; ++i)
				for (size_t j = i + 1; j < i + n; ++j)
					ans = min(ans,
					          sqr(K * (pl[i + n] - pl[j]) - sumofs) +
					          sqr(K * (pl[j] - pl[i]) - sumofs));
		else if (K == 3)
		{
			srand(time(NULL));
			while (clock() <= 950)
			{
				const size_t f = rand() % n;
				const size_t k = rand() % (n - 2) + 1;
				const size_t g = rand() % (n - k - 1) + 1;
				ans = min(ans,
				          sqr(K * (pl[f + k] - pl[f]) - sumofs) +
				          sqr(K * (pl[f + k + g] - pl[f + k]) - sumofs) +
				          sqr(K * (pl[f + n] - pl[f + k + g]) - sumofs));
			}
		}
	}
	cout << ans << endl;
	return 0;
}
