#include<iostream>
#include<algorithm>
#include<cmath>
#include<cstdio>
#include<cstring>
using namespace std;
const int oo = 1e9;
int n,m;
int mn,mx;
int ins[100010];
void g_s()
{
	string a;	int b,c;
	for(int i = 1;i <= m;i ++){
		cin >> a >> b >> c;
		if(a == "merge"){
			ins[b] = c;
			for(int j = b + 1;j < n;j ++)
				ins[j] = ins[j + 1];
			n --;
		}
		if(a == "insert"){
			for(int j = n + 1;j >= b + 2;j --)
				ins[j] = ins[j - 1];
			ins[b + 1] = c;
			n ++;
		}
		if(a == "max"){
			mn = oo;	mx = -oo;
			for(int j = b;j <= c;j ++){
				mn = min(mn,ins[j]);
				mx = max(mx,ins[j]);
			}
			cout << mx - mn << endl;
		}
		if(a == "min"){
			mn = oo;
			for(int j = b;j < c;j ++)
				mn = min(mn,ins[j + 1] - ins[j]);
			cout << mn << endl;
		}
	}
	exit(0);	
}
//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^
////^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//^^//
typedef struct node
{
	int st,ed;
	node *l,*r;
	int mx,mn;
	int mnblock;
	int lv,rv;
	node(int stt,int edd,int mxx,int mnn,int mnblockk,node *ll,node *rr,int lvv,int rvv){
		st = stt;	ed = edd;	mx = mxx;	mn = mnn;
		l = ll;	r = rr;	mnblock = mnblockk;	lv = lvv;	rv = rvv;
	}
}*pnode;
void update(pnode &r)
{
	r->mn = min(r->l->mn, r->r->mn);
	r->mx = max(r->l->mx, r->r->mx);
	r->mnblock = min(min(r->l->mnblock,r->r->mnblock),abs(ins[r->r->st] - ins[r->l->ed]));
	r->lv = r->l->lv;
	r->rv = r->r->rv;
}
pnode build(int st,int ed)
{
	if(st == ed){
		pnode ne = new node(st,ed,ins[st],ins[ed],oo,0,0,ins[st],ins[ed]);
		return ne;
	}
	int mid = (st + ed)>>1;
	pnode ne = new node(st,ed,0,0,0,build(st,mid),build(mid + 1,ed),0,0);
	update(ne);
	return ne;
}
void search_lim(pnode r, int st, int ed)
{
	if(r->st >= st && r->ed <= ed){
		mn = min(mn,r->mn);
		mx = max(mx,r->mx);
		return;
	}
	if(st <= r->l->ed)	search_lim(r->l,st,ed);
	if(ed >= r->r->st)	search_lim(r->r,st,ed);
}
void search_mb(pnode r, int st, int ed)
{
	if(r->st >= st && r->ed <= ed){
		mn = min(mn,r->mnblock);
		return;
	}
	int cnt = 0;
	if(st <= r->l->ed)	search_mb(r->l,st,ed),cnt ++;
	if(ed >= r->r->st)	search_mb(r->r,st,ed),cnt ++;
	if(cnt == 2)	mn = min(mn,abs(r->r->lv - r->l->rv));
}
pnode root;
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for(int i = 1;i <= n;i ++)	cin >> ins[i];
//	if(n <= 1000)	g_s();
	root = build(1,n);
	string inn;
	int x,y;
	for(int i = 1;i <= m;i ++){
		cin >> inn >> x >> y;
		if(inn == "max"){
			mn = oo,mx = -oo;
			search_lim(root,x,y);
			cout << mx - mn << endl;
		}
		if(inn == "min"){
			mn = oo;
			search_mb(root,x,y);
			cout << mn << endl;
		}
		else
			cout << "killing me" << endl;
	}
	return 0;
}
/*
4 3
5 8 10 2
max 1 3
min 1 3
max 2 4

6 7
1 2 3 4 5 6
insert 1 3
max 2 4
merge 1 2
max 2 4
min 2 4
insert 6 1
max 5 7
*/
