#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
#include<cstring>
#include<ctime>
using namespace std;
const long long oo = 1e15;
int n,k;
int len[300030],s[600060];
long long dp[440][440][22];
long long fans = oo;
long long sqr(int x){return (long long)x * x;}
void ini()
{
	for(int i = 1;i <= n;i ++)
		for(int j = 1;j <= n;j ++)
			for(int kk = 1;kk <= n;kk ++)
				dp[i][j][kk] = oo;
}
void roll()
{
	int l1 = len[1];
	for(int i = 1;i < n;i ++){
		len[i] = len[i + 1];
		s[i] = s[i - 1] + len[i];
	}
	len[n] = l1;
	s[n] = s[n - 1] + len[n];
}
long long lai(int l,int r,long long goal,int c)
{
	if(l == r)	return (r + l)>>1;
	int mid = (l + r)>>1;
	long long now;
	if(2 * (s[mid] - s[c]) == goal)	return mid;
	if(2 * (s[mid] - s[c]) < goal)	return lai(mid + 1,r,goal,c);
	if(2 * (s[mid] - s[c]) > goal)	return lai(l,mid,goal,c);
}
void solve()
{
	if(k == 2){
		long long pans;
		for(int i = 1;i <= n;i ++){
			pans = lai(i + 1,i + n,s[n],i);
			fans = min(fans,sqr((s[pans] - s[i])*2 - s[n]) * 2);
		}
		cout << fans << endl;
		exit(0);
	}
	exit(0);
}

int main()
{
	freopen("spaceship.in","r",stdin);
	freopen("spaceship.out","w",stdout);
	ios::sync_with_stdio(false);
	cin >> n >> k;
	for(int i = 1;i <= n;i ++){
		cin >> len[i];
		s[i] = s[i - 1] + len[i];
	}
	for(int i = n + 1;i <= 2 * n;i ++)	s[i] = s[i - 1] + len[i - n];
	if(n == 100000 || n == 300000)	
		solve();
	ini();
	for(int st = 1;st <= n;st ++){
//		for(int i = 1;i <= n;i ++)	cout << s[i] << " ";
//		cout << endl;
		dp[st][0][0] = 0;
		for(int i = 0;i < n;i ++)
			for(int j = 0;j < k;j ++){
				if(dp[st][i][k] == oo)	break;
				for(int l = i + 1;l <= n;l ++)
					dp[st][l][j + 1] = min(dp[st][i][j] + sqr(s[n] - k * (s[l] - s[i])),dp[st][l][j + 1]);
			}
		fans = min(fans,dp[st][n][k]);
		roll();
	}
	cout << fans << endl;
	return 0;
}
/*
5 2
4 2 7 1 3
*/

