#include <iostream>
#include <cmath>
#include <cstdio>

using namespace std;

const int MAXN=3e5+5;

const long long oo=(1ll<<62)-1+(1ll<<62);

int n, m;

int a[MAXN]={0};

int s[MAXN]={0};

long long f[MAXN][25];

int sum=0;

long long square(int x)
{
	return x*x;
}

long long mn;

int main()
{
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	for (int i=1; i<=n; ++i)
	{
		cin >> a[i];
		s[i]=s[i-1]+a[i];
	}
	sum=s[n];
	f[0][0]=0;
	for (int i=1; i<=n; ++i)
		f[i][1]=square(s[i]*m-sum);
	for (int i=1; i<=n; ++i)
	{
		for (int j=2; j<=m; ++j)
		{
			f[i][j]=oo;
			if (j > i)
				continue;
			for (int k=1; k<=i-j+1; ++k)
			{
				long long poi=f[i-k][j-1];
				if (poi == oo)
					continue;
				int x=s[i]-s[i-k];
				long long nico=poi+square(x*m-sum);
				if (f[i][j] > nico)
					f[i][j]=nico;
			}
			/*
			cout << "i = " << i << "  j = " << j << endl;
			cout << f[i][j] << endl << endl;*/
		}
	}
	mn=f[n][m];
	/*
	cout << "sum = " << sum << endl << "m = " << m << endl;
	cout << "--------" << endl;*/
	for (int t=2; t<=n; ++t)
	{
		int tmp=a[1];
		for (int l=2; l<=n; ++l)
		{
			a[l-1]=a[l];
		}
		a[n]=tmp;
		s[1]=a[1];
		for (int l=2; l<=n-1; ++l)
			s[l]=s[l-1]+a[l];
		s[n]=sum;
		for (int i=1; i<=n; ++i)
			f[i][1]=square(s[i]*m-sum);
			
		for (int i=1; i<=n; ++i)
		{
			for (int j=2; j<=m; ++j)
			{
				f[i][j]=oo;
				if (j > i)
					continue;
				for (int k=1; k<=i-j+1; ++k)
				{
					long long poi=f[i-k][j-1];
					if (poi == oo)
						continue;
					int x=s[i]-s[i-k];
					long long nico=poi+square(x*m-sum);
					if (f[i][j] > nico)
						f[i][j]=nico;
				}
				/*
				cout << "i = " << i << "  j = " << j << endl;
				cout << f[i][j] << endl << endl;*/
			}
		}
		long long tmpp=f[n][m];
		if (mn > tmpp)
		{
			//cout << "oohoho" << endl;
			mn=tmpp;
		}
	}
	
	cout << mn << endl;
	
	return 0;
}

