#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

const int inf = 2147483647;
int n, m;
string op;
int xx, yy;
int Next[300010], start, a[300010], Max = -inf, Min = inf;
int EID = 1;

inline int read()
{
	int a = 0;
	char ch;
	bool flag = false;
	while(!((((ch = getchar()) >= '0') && (ch <= '9')) || (ch == '-')));
	if(ch == '-')
		flag = true;
	else
	{
		a = a * 10;
		a += ch - '0';
	}
	while((((ch = getchar()) >= '0') && (ch <= '9')) || (ch == '-'))
	{
		a = a * 10;
		a += ch - '0';
	}
	if(flag)
		a = -a;
	return a;
}

inline void open()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
}

inline void close()
{
	fclose(stdin);
	fclose(stdout);
}

inline void print()
{
	for(int i = start;i != 0;i = Next[i])
		cout << a[i] << " ";
	cout << endl;
}

inline void scanff()
{
	n = read();m = read();
	for(int i = 1;i <= n;++i)
	{
		a[i] = read();
		Next[i] = i + 1;
	}
	Next[n] = 0;
	start = 1;
	for(int i = 1;i <= m;++i)
	{	
		
		cin >> op;
		xx = read();yy = read();
		if(op[0] == 'm' && op[1] == 'a')
		{
			Max = -inf;Min = inf;
			int j = 1, i = start;
			while(j < xx)
				i = Next[i], j++;
			while(j <= yy)
			{
				if(a[i] > Max)
					Max = a[i];
				if(a[i] < Min)
					Min = a[i];
				i = Next[i];
				j++;
			}
			cout << Max - Min << endl;
		}
		else if(op[0] == 'm' && op[1] == 'i')
		{
			Min = inf;
			int j = 1, i = start;
			while(j < xx)
				i = Next[i], j++;
			while(j <= yy)
			{
				int x = Next[i], k = j + 1;
				while(k <= yy)
				{
					if(abs(a[x] - a[i]) < Min)
						Min = abs(a[x] - a[i]);
					x = Next[x];
					k++;
				}
				i = Next[i];
				j++;
			}
			cout << Min << endl;
		}
		else if(op[0] == 'm' && op[1] == 'e')
		{
			int j = 1, i = start;
			while(j < xx)
				i = Next[i], j++;
			int t = Next[Next[i]];
			Next[Next[i]] = 0;
			Next[i] = t;
			a[i] = yy;
		}
		else if(op[0] == 'i')
		{
			int j = 1, i = start;
			while(j < xx)
				i = Next[i], j++;
			a[n + EID] = yy;
			Next[n + EID] = Next[i];
			Next[i] = n + EID;
			EID++;
		}
		//print();
	}
}
	


int main()
{
	open();
	scanff();
	close();
	return 0;
}
