#include <queue>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
using namespace std;


int num[600020], qsum[300010];
int n, k, EID = 0;
double s_avg = 0;
double ans1[100];
bool vis[300010];

inline int read()
{
	int a = 0;
	char ch;
	bool flag = false;
	while(!((((ch = getchar()) >= '0') && (ch <= '9')) || (ch == '-')));
	if(ch == '-')
		flag = true;
	else
	{
		a = a * 10;
		a += ch - '0';
	}
	while((((ch = getchar()) >= '0') && (ch <= '9')) || (ch == '-'))
	{
		a = a * 10;
		a += ch - '0';
	}
	if(flag)
		a = -a;
	return a;
}

inline void open()
{
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
}

inline void close()
{
	fclose(stdin);
	fclose(stdout);
}

inline void scanff()
{
	n = read();k = read();
	for(int i = 1;i <= n;++i)
	{
		num[i] = read();
		qsum[i] = qsum[i - 1] + num[i];
		num[i + n] = num[i];
	}
	for(int i = n + 1;i <= n + n;++i)
		qsum[i] = qsum[i - 1] + num[i];
}

inline void solve()
{
	int cur = 0;
	const double cmp = (double)qsum[n] / (double)k;
	//cout << cmp << endl;
	if(k == n)
	{
		for(int i = 1;i <= k;++i)
		{
			ans1[i] = num[i];
		}
	}
	else
	{
		for(int kase = 1;kase <= k;++kase)
		{
			int first = 0, last = 0, cnt = 0;
			cur++;
			while(1)
			{
				if(vis[cur % n])
				{
					if(cnt < cmp)
						ans1[kase] = cnt;
					break;
				}
				cnt += num[cur];
				//cout << cur << " " << num[cur] << endl;
				if(first == 0)
					first = cur;
				last = cur;
				if(cnt == cmp)
				{
					for(int i = first;i <= last;++i)
						vis[i % n] = 1;
					ans1[kase] = cnt;
					break;
				}
				if((cnt > cmp))
				{
					if(cnt - num[first] <= cmp && cnt - num[last] > cmp)
					{
						cnt -= num[last];
						last--;
						for(int i = first;i <= last;++i)
							vis[i % n] = 1;
						ans1[kase] = cnt;
						break;
					}
					else if(cnt - num[last] <= cmp && cnt - num[first] > cmp)
					{
						cnt -= num[first];
						first++;
						for(int i = first;i <= last;++i)
							vis[i % n] = 1;
						ans1[kase] = cnt;
						break;
					}
					else if(cnt - num[first] <= cmp && cnt - num[last] <= cmp)
					{
						if(cnt - num[first] == cmp)
						{
							cnt -= num[first];
							first++;
							for(int i = first;i <= last;++i)
								vis[i % n] = 1;
							ans1[kase] = cnt;
							break;
						}
						else if(cnt - num[last] == cmp)
						{
							cnt -= num[last];
							last--;
							for(int i = first;i <= last;++i)
								vis[i % n] = 1;
							ans1[kase] = cnt;
							break;
						}
						else
						{
							for(int i = first;i <= last;++i)
								vis[i % n] = 1;
							ans1[kase] = cnt;
							break;
						}
					}
				}
				cur++;
			}
		}
	}
	double ans2 = 0;
	for(int i = 1;i <= k;++i)
	{
		//cout << ans1[i] << " ";;
		ans2 += (ans1[i] - cmp) * (ans1[i] - cmp);
		//cout << "ans2 = " << ans2 << endl;
	}
	//cout << endl;
	cout << ans2 * k * k << endl;
}

int main()
{
	open();
	scanff();
	solve();
	close();
	return 0;
}
