#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>

using namespace std;

const int Max = 1000100;
const int oo = 2147483647;

int n,m;
int a[Max]={0};

int main()
{
	std::ios::sync_with_stdio(false);
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	
	cin>>n>>m;
	for(int i=1;i<=n;i++)
		cin>>a[i];
	for(int T=1;T<=m;T++)
	{
		string s;
		cin>>s;
		int x,y;
		cin>>x>>y;
		int mmax,mmin;
		switch(s[1])
		{
			case 'e':
				a[x]=y;
				for(int i=x+1;i<n;i++)
					a[i]=a[i+1];
				n--;
				break;
			case 'n':
				
				for(int i=n;i>x;i--)
					a[i+1]=a[i];
				n++;
				a[x+1]=y;
				break;
			case 'a':
				mmax=-1;mmin=oo;
				for(int i=x;i<=y;i++)
				{
					if(a[i] > mmax) mmax = a[i];
					if(a[i] < mmin) mmin = a[i];
				}
				cout<<mmax-mmin<<endl;
				break;
			case 'i':
				mmin = oo;
				for(int i=x;i<y;i++)
				{
					if(abs(a[i]-a[i+1]) < mmin)
						mmin = abs(a[i]-a[i+1]);
				}
				cout<<mmin<<endl;
				break;
		}
	}
	return 0;
}
/*
6 7 
1 2 3 4 5 6 
insert 1 3 
max 2 4 
merge 1 2 
max 2 4 
min 2 4 
insert 6 1 
max 5 7
*/
