#include<iostream>
#include<cstdio>
#include<string>
#include<algorithm>
#include<cstring>
using namespace std;
int n, m;
int a[100005];
int st[100005];
const int inf = 1<<30;

struct node{
	int maxx;
	int minn;
}tree[400100];

void copy(int l, int r){
	memset(st,0,sizeof(st));
	int i;
	for(i = 0; i < r-l+1; i++)
		st[i] = a[i+l];
}

void build(int no, int l, int r){
	node p;
	if(l == r){
		p.maxx = p.minn = a[l];
		tree[no] = p; 
		return;
	}
	int m = (l+r)/2;
	build(2*no, l, m);
	build(2*no+1, m+1, r);
	tree[no].maxx = max(tree[2*no].maxx,tree[2*no+1].maxx);
	tree[no].minn = min(tree[2*no].minn,tree[2*no+1].minn);
}

int qmax(int no, int begin, int end, int l, int r){
	if(l>end||r<begin) 
		return -1;
	if(begin>=l&&end<=r)
		return tree[no].maxx;
	int q1 = qmax(no*2, begin, (begin+end)/2, l, r);
	int q2 = qmax(no*2+1, (begin+end)/2+1, end, l, r);
	if(q1==-1) return q2;
	if(q2==-1) return q1;
	if(q1==q2) return q1;
	return max(q1, q2);
}

int qmin(int no, int begin, int end, int l, int r){
	if(l>end||r<begin) 
		return -1;
	if(begin>=l&&end<=r)
		return tree[no].minn;
	int q1 = qmin(no*2, begin, (begin+end)/2, l, r);
	int q2 = qmin(no*2+1, (begin+end)/2+1, end, l, r);
	if(q1==-1) return q2;
	if(q2==-1) return q1;
	if(q1==q2) return q1;
	return min(q1, q2);
}
int main(){
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);	
	cin>>n>>m;
	int i, j;
	for(i = 1; i <= n; i++){
		cin>>a[i];
	}
	build(1, 1, n);
	for(i = 1; i <= m; i++){
		char a[10];
		cin>>a;
		if(a[1] == 'a'){
			int l, r;
			cin>>l>>r;
			int maxx = qmax(1,1,n,l,r);
			int minn = qmin(1,1,n,l,r);
			cout<<maxx-minn<<endl;
		}
		else if(a[1] == 'i'){
			int l, r;
			cin>>l>>r;
			copy(l, r);
			sort(st, st+r-l+1);
			int small = inf;
			for(j = 0; j < r-l; j++)
				small = min(st[j+1]-st[j], small);
			cout<<small<<endl;
		}
//		else{
//			int l, r;
//			cin>>l>>r;
//			cout<<'0'<<endl;
//		}
	}
//	for(i = 1; i <= 4*n+1; i++){
//		cout<<i<<":"<<tree[i].maxx<<" "<<tree[i].minn<<endl;
//	}
//	cout<<qmax(1,1,6,2,4)<<endl;
//	cout<<qmin(1,1,6,2,4)<<endl;
	return 0;
}
