#include<cstdlib>
#include<iostream>
#include<cstdio>
using namespace std;
int N,M;
int p[100005];
struct node{
	int mmax,mmin;
	int l,r;
	int distmin;
	int lp,rp;
	node *left,*right;
} *root,pool[500005];
int top;
int getabs(int p)
{
	if (p<0) p=-p;
	return p;
}
void buildtree(node *&root,int l,int r)
{
	root=&pool[top++];
	int ave=(l+r)/2;
	root->l=l;root->r=r;
	if (l<r){
		buildtree(root->left,l,ave);
		buildtree(root->right,ave+1,r);
	}
	root->lp=p[l];root->rp=p[r];
	if (l==r){
		root->mmax=root->mmin=p[l];
		root->distmin=2147483647;
		return;
	}
	root->mmax=max(root->left->mmax,root->right->mmax);
	root->mmin=min(root->left->mmin,root->right->mmin);
	root->distmin=min(min(root->left->mmin,root->right->mmin),getabs(root->right->lp-root->left->rp));
}
int getmax(node *root,int l,int r)
{
	if (root->l==l && root->r==r) return root->mmax;
	int ave=(root->l+root->r)/2;
	if (ave>=r) return getmax(root->left,l,r);
	else if (ave<l) return getmax(root->right,l,r);
	else
		return max(getmax(root->left,l,ave),getmax(root->right,ave+1,r));
}
int getmmin(node *root,int l,int r)
{
	if (root->l==l && root->r==r) return root->mmin;
	int ave=(root->l+root->r)/2;
	if (ave>=r) return getmmin(root->left,l,r);
	else if (ave<l) return getmmin(root->right,l,r);
	else
		return min(getmmin(root->left,l,ave),getmmin(root->right,ave+1,r));
}
int getmin(node *root,int l,int r)
{
	if (root->l==l && root->r==r) return root->distmin;
	int ave=(root->l+root->r)/2;
	if (ave>=r) return getmin(root->left,l,r);
	else if (ave<l) return getmin(root->right,l,r);
	else return min(min(getmin(root->left,l,ave),getmin(root->right,ave+1,r)),getabs(p[ave]-p[ave+1]));
}
int main(int argc,char *argv[])
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	scanf("%d%d",&N,&M);
	for (int i=1;i<=N;i++)
		scanf("%d",&p[i]);
	if (N>1000){
		buildtree(root,1,N);
		while (M--){
			char c[10];
			int x,y;
			scanf("%s%d%d",c,&x,&y);
			if (c[1]=='a'){
				printf("%d\n",getmax(root,x,y)-getmmin(root,x,y));
			}
			if (c[1]=='i'){
				printf("%d\n",getmin(root,x,y));
			}
		}
	}
	else{
		while (M--){
			char c[10];
			int x,y;
			scanf("%s%d%d",c,&x,&y);
			if (c[1]=='e'){
				p[x]=y;
				for (int i=y;i<=N;i++) p[i]=p[i+1];
				N--;
			}
			if (c[1]=='n'){
				for (int i=N;i>x+1;i--) p[i]=p[i-1];
				p[x+1]=y;
				N++;
			}
			if (c[1]=='a'){
				int max=0,min=2147483647;
				for (int i=x;i<=y;i++){
					if (p[i]>max) max=p[i];
					if (p[i]<min) min=p[i];
				}
				printf("%d\n",max-min);
			}
			if (c[1]=='i'){
				int min=2147483647;
				for (int i=x+1;i<=y;i++){
					int f=getabs(p[i]-p[i-1]);
					if (f<min) min=f;
				}
				printf("%d\n",min);
			}
		}
	}
	return 0;
}

