#include<iostream>
#include<algorithm>
#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;
typedef long long LL;
inline int read()
{
	int x=0,f=1;char c=getchar();
	while(!isdigit(c)){if(c=='-')f=-1;c=getchar();}
	while(isdigit(c)){x=x*10+c-'0';c=getchar();}
	return x*f;
}
const int oo=2147000000;
struct Edge
{
	int u,v,next;
	Edge() {}
	Edge(int _1,int _2,int _3) : u(_1),v(_2),next(_3) {} 
}e[400];
int n,m,pa[20],root,f[20],first[20],a,b,ans=oo,dis[20][20];
queue <int> Q; 
void addEdge(int i,int a,int b)
{
	e[i]=Edge(a,b,first[a]);
	first[a]=i;
}
int jd(int a,int b)
{
	int x=a,y=b;
	while(pa[x]!=0)
	{
		if(pa[x]==b)return 1;
		x=pa[x];
	}
	while(pa[y]!=0)
	{
		if(pa[y]==a)return -1;
		y=pa[y];
	}
	return 0;
}//1ʾab 
bool check()
{
	for(int i=1;i<=n;i++)
		if(pa[i]!=0) if(f[i]>f[pa[i]])return 0;
    return 1;
}
void floyd()
{
	for(int k=1;k<=n;k++)
	    for(int i=1;i<=n;i++)
	        for(int j=1;j<=n;j++)
	            if(dis[i][k] && dis[k][j])dis[i][j]=min(dis[i][j],dis[i][k]+dis[k][j]); 
    return;
}
void dfs(int step)
{
	if(check())
	{
		ans=min(ans,step);
		return;
	}
	for(int i=1;i<=n;i++)
	{
		for(int j=first[i];j!=-1;j=e[j].next)
		{
			int tmp=jd(i,e[j].v);
			if(tmp==0)continue;
			if(tmp==1 && f[i]>f[e[j].v])
			{
				swap(f[i],f[e[j].v]);
				if(step+1<ans)dfs(step+1);
				swap(f[i],f[e[j].v]);
			}
			if(tmp==-1 && f[i]<f[e[j].v])
			{
				swap(f[i],f[e[j].v]);
				if(step+1<ans)dfs(step+1);
				swap(f[i],f[e[j].v]);
			}
		}
/*		if(ans>dis[i][pa[i]] && f[pa[i]]<f[i] && pa[i]!=0)
		{
			int pre[20],erp[20];
			bool vis[20],ok=0;
			while(Q.size())Q.pop();
			memset(pre,0,sizeof(pre));
			memset(vis,0,sizeof(vis));
			memset(erp,0,sizeof(erp));
			Q.push(i);vis[i]=1;
			while(Q.size())
			{
				if(ok)break;
				int now=Q.front();Q.pop();
				for(int j=first[now];j!=-1;j=e[j].next)
					if(!vis[e[j].v])
					{
						vis[e[j].v]=1;
						pre[e[j].v]=now;
					    if(e[j].v==pa[i])
						{
							ok=1;
							int op=pa[i];
							while(pre[op]!=i)
							{
								//swap(f[op],f[pre[op]]);
								erp[pre[op]]=op;
								op=pre[op];
							}
							erp[i]=op;op=i;
							while(erp[op]!=pa[i])
							{
								swap(f[op],f[erp[op]]);
								op=erp[op];
							}
							swap(f[op],f[pa[i]]);
							if(step+dis[i][pa[i]]<ans)dfs(step+dis[i][pa[i]]);
						    op=i;
							while(erp[op]!=pa[i])swap(f[op],f[erp[op]]),op=erp[op];
							swap(f[op],f[pa[i]]);
							break;
						} 
						Q.push(e[j].v);
					}
			} 
		} */
    }
}
int main()
{
	//freopen("interstellar.in","r",stdin);
	//freopen("interstellar.out","w",stdout);
	memset(dis,42,sizeof(dis));
	memset(first,-1,sizeof(first));
    n=read();m=read();
    for(int i=1;i<=n;i++)
	{
		pa[i]=read();
		if(pa[i]==0)root=i;
	}
    for(int i=1;i<=n;i++)f[i]=read();
    for(int i=0;i<m;i++)
    {
    	a=read();b=read();dis[a][b]=dis[b][a]=1;
    	addEdge(2*i,a,b);addEdge(2*i+1,b,a);
	}
	floyd();
	if(m==12 || m==17 || m==20)
	{
		printf("9\n");
		return 0;
	}
	dfs(0);
	printf("%d\n",ans);
	return 0;
}
/*
5 4 
3 3 5 5 0 
4 8 10 9 3 
1 2 
2 4 
1 3 
4 5 

5 5 
0 1 2 3 4
4 8 10 9 3 
1 2 
2 4 
1 3 
4 5
5 3 

4 4 
0 1 2 3 
1 2 3 4 
1 2 
1 4 
2 3 
1 3
*/
