#include <cstdio>
#include <algorithm>
using namespace std;

#define int long long
const int _P=300007;

int piece[_P*2],presum[_P*2],pieces,sum;

inline int po(int x) {
	return x*x;
}

int min3val=2147483647;
void addline(int pos,int togo,int l1,int l2,int l3) { // todo: check 0
	if(togo==0) {
		int s1=presum[l2]-presum[l1],
			s2=presum[l3]-presum[l2],
			s3=presum[l1+pieces]-presum[l3];
		min3val=min(min3val,po(3*s1-sum)+po(3*s2-sum)+po(3*s3-sum));
	}
	if(pos>pieces) return;
	else {
		                 addline(pos+1,togo,l1,l2,l3);
		     if(togo==3) addline(pos+1,2,pos,l2,l3);
		else if(togo==2) addline(pos+1,1,l1,pos,l3);
		else if(togo==1) addline(pos+1,0,l1,l2,pos);
	}
}

#undef int
int main() {
#define int long long
	freopen("spaceship.in","r",stdin);
	freopen("spaceship.out","w",stdout);

	int target;
	scanf("%lld%lld",&pieces,&target);
	for(int i=1;i<=pieces;i++) {
		scanf("%lld",piece+i);
		sum+=piece[i];
	}
	for(int i=pieces+1;i<=2*pieces;i++)
		piece[i]=piece[i-pieces];
	for(int i=1;i<=2*pieces;i++)
		presum[i]=presum[i-1]+piece[i];
		
	int minval=2147483647,minl,minr;
	if(target==2) {
		for(int offset=1;offset<=pieces;offset++) {
			int l=offset,r=offset+pieces-1;
			while(l<r) {
				int mid=(l+r)>>1;
				if((presum[mid]-presum[offset-1])<<1 < sum)
					l=mid+1;
				else
					r=mid;
			}
			int res_1=((presum[l]-presum[offset-1])<<1) - sum,
				res_2=sum - ((presum[l-1]-presum[offset-1])<<1);
			//printf("offset = %d ; result = %d ; res1 = %d ; res2 = %d\n",offset,l,res_1,res_2);
			if(res_1<minval)
				minval=res_1,
				minl=offset,
				minr=l;
			if(res_2<minval)
				minval=res_2,
				minl=offset,
				minr=l-1;
		}
		//printf("%d ~ %d\n",minl,minr);
		int s=presum[minr]-presum[minl-1];
		printf("%lld\n",po(2*s-sum)+po(sum-2*s));
	} else if(target==3) {
		addline(0,3,0,0,0);
		printf("%lld\n",min3val);
	} else
		puts("0"); // god bless me
	return 0;
}
