#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<map>
#include<vector>
#include<queue>
#include<stack>
#include<sstream>
using namespace std;
const int oo=1e9;
int max(const int &a,const int &b)
{
	return ((abs(a)>abs(b))?a:b);
}
int min(const int &a,const int &b)
{
	return ((abs(a)<abs(b))?a:b);
}
int max(const int &a,const int &b,const int &c)
{
	return ((abs(a)>abs(b)&&abs(a)>abs(c))?a:((abs(b)>abs(c))?b:c));
}
int min(const int &a,const int &b,const int &c)
{
	return ((abs(a)<abs(b)&&abs(a)<abs(c))?a:((abs(b)<abs(c))?b:c));
}
struct Node
{
	int s,lmx,rmx,mx,lmn,rmn,mn;
	Node():s(0),lmx(0),rmx(0),mx(0),lmn(oo),rmn(oo),mn(oo){}
	friend ostream &operator<<(ostream &out,const Node &a)
	{
		out<<a.s<<" "<<a.lmx<<" "<<a.rmx<<" "<<a.mx<<" "<<a.lmn<<" "<<a.rmn<<" "<<a.mn;
		return out;
	}
	Node &operator=(const int &v)
	{
		s=lmx=rmx=mx=lmn=rmn=mn=v;
		return *this;
	}
}h[1000005];
Node merge(const Node &l,const Node &r)
{
	Node p;
	p.s=l.s+r.s;
	p.lmx=max(l.lmx,l.s+r.lmx);
	p.rmx=max(r.rmx,r.s+l.rmx);
	p.mx=max(l.mx,r.mx,l.rmx+r.lmx);
	p.lmn=min(l.lmn,l.s+r.lmn);
	p.rmn=min(r.rmn,r.s+l.rmn);
	p.mn=min(l.mn,r.mn,l.rmn+r.lmn);
	return p;
}
vector<int>now;
int sum;
void set_tree()
{
	for(sum=1;sum<now.size()+2;sum<<=1);
	for(int i=1;i<now.size();i++)
		h[sum+i]=now[i]-now[i-1];
	for(int i=sum-1;i;i--)
		h[i]=merge(h[i<<1],h[i<<1|1]);
}
Node getm(const int &l,const int &r)
{
	Node left,right;
	for(int s=l+sum-1,t=r+sum+1;s^t^1;s>>=1,t>>=1)
	{
		if((~s&1))
			left=merge(left,h[s^1]);
		if((t&1))
			right=merge(h[t^1],right);
	}
	return merge(left,right);
}
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	std::ios::sync_with_stdio(false);
	int n,m;
	cin>>n>>m;
	for(int i=1;i<=n;i++)
	{
		int e;
		cin>>e;
		now.push_back(e);
	}
	set_tree();
	for(int i=1;i<=m;i++)
	{
		string s;
		int x,y;
		cin>>s>>x>>y;
		if(s=="max")
			cout<<abs(getm(x,y-1).mx)<<endl;
		else if(s=="min")
			cout<<abs(getm(x,y-1).mn)<<endl;
		else if(s=="insert")
		{
			now.push_back(y);
			for(int j=now.size()-1;j>x;j--)
				swap(now[j],now[j-1]);
			set_tree();
		}
		else if(s=="merge")
		{
			now[x-1]=y;
			for(int j=x;j<now.size()-1;j++)
				swap(now[j],now[j+1]);
			now.pop_back();
			set_tree();
		}
		else
			continue;
	}
	
	return 0;
}
/*
4 2
1 11 12 9
max 1 3
max 1 4
*/
