#include <iostream>
#include <vector>
#include <cmath>

//60% 

using namespace std;

const int MAXN = 100005;

struct Node
{
	int MIN;
	int MAX;
	int MINABS;
	Node()
	{
		MIN = MINABS = 999999999;
		MAX = 0;
	}
};

int n,m;
int s,x,y;
int k[MAXN];
int min_[2 * MAXN];
int max_[2 * MAXN];
int abs_[2 * MAXN];

string type;

vector<int> v;

void build_tree(int o,int l,int r)
{
	if (l == r)
	{
		min_[o] = k[l];
		max_[o] = k[l];
		abs_[o] = 999999999;
		return;
	}
	int mid = (l + r) >> 1;
	build_tree(o << 1,l,mid);
	build_tree((o << 1) + 1,mid + 1,r);
	min_[o] = min(min_[o << 1],min_[(o << 1) + 1]);
	max_[o] = max(max_[o << 1],max_[(o << 1) + 1]);
	abs_[o] = min(abs_[o << 1],abs_[(o << 1) + 1]);
	abs_[o] = min(abs_[o],abs(k[mid] - k[mid + 1]));
}

int get_min(int o,int l,int r)
{
	if (r < x || l > y)
		return 999999999;
	if (l >= x && r <= y)
		return min_[o];
	int mid = (l + r) >> 1;
	return min(get_min(o << 1,l,mid),get_min((o << 1) + 1,mid + 1,r)); 
}

int get_max(int o,int l,int r)
{
	if (r < x || l > y)
		return 0;
	if (l >= x && r <= y)
		return max_[o];
	int mid = (l + r) >> 1;
	return max(get_max(o << 1,l,mid),get_max((o << 1) + 1,mid + 1,r)); 
}

int get_abs(int o,int l,int r)
{
	if (r < x || l > y)
		return 999999999;
	if (l >= x && r <= y)
		return abs_[o];
	int mid = (l + r) >> 1;
	return min(abs(k[mid] - k[mid + 1]),min(get_abs(o << 1,l,mid),get_abs((o << 1) + 1,mid + 1,r))); 
}

int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	ios::sync_with_stdio(false);
	cin >> n >> m;
	if (m <= 1000)
	{
		for (int i = 1;i <= n;i++)
		{
			cin >> s;
			v.push_back(s);
		}
		for (int i = 1;i <= m;i++)
		{
			cin >> type >> x >> y;
			x--;
			if (type == "merge")
			{
				v.erase(v.begin() + x);
				v.erase(v.begin() + x);
				v.insert(v.begin() + x,y);
			}
			if (type == "insert")
				v.insert(v.begin() + x + 1,y);
			if (type == "max")
			{
				y--;
				int MIN = 999999999,MAX = 0;
				for (int j = x;j <= y;j++)
					MIN = min(MIN,v[j]),MAX = max(MAX,v[j]);
				cout << MAX - MIN << endl;
			}
			if (type == "min")
			{
				y--;
				int MIN = 999999999;
				for (int j = x;j < y;j++)
					MIN = min(MIN,abs(v[j] - v[j + 1]));
				cout << MIN << endl;
			}
		}
	}
	else
	{
		for (int i = 1;i <= n;i++)
			cin >> k[i];
		build_tree(1,1,n);
		for (int i = 1;i <= m;i++)
		{
			cin >> type >> x >> y;
			if (type == "max")
				cout << get_max(1,1,n) - get_min(1,1,n) << endl;
			if (type == "min")
				cout << get_abs(1,1,n) << endl;
		}
	}
	return 0;
}
