#include <iostream>
#include <cstring>
#include <sstream>

using namespace std;

const int MAXN = 300005;

long long sum[2 * MAXN];
long long s[2 * MAXN];
long long avg;
long long n,k,ans = 999999999999;
long long st,ed;

bool ok;

long long sqr(long long k)
{
	return k * k;
}

long long get_mid(long long now)
{
	long long low = now,high = ed;
	while (low <= high)
	{
		long long mid = (low + high) / 2;
		if (sum[mid] - sum[now - 1] == avg)
		{
			ok = 1;
			return mid;
		}
		else if (sum[mid] - sum[now - 1] < avg && sum[mid + 1] - sum[now - 1] > avg)
			return mid;
		else if (sum[mid] - sum[now - 1] > avg)
			high = mid - 1;
		else
			low = mid + 1;
	}
	if (s[now] > avg)
		return now;
	else
		return ed;
}

long long dfs(long long k,long long now)
{
	if (ed - now + 1 < k)
		return 999999999999;
	if (k == 1)
		return sqr(sum[ed] - sum[now - 1]);
	long long flag = get_mid(now);
	if (ok)
	{
		ok = false;
		long long ret = dfs(k - 1,flag + 1);
		return ret == 999999999999 ? ret : ret + sqr(sum[flag] - sum[now - 1]);
	}
	long long ret1 = dfs(k - 1,flag + 1);
	long long ret2 = dfs(k - 1,flag + 2);
	return min((ret1 == 999999999999 ? ret1 : ret1 + sqr(sum[flag] - sum[now - 1])),(ret2 == 999999999999 ? ret2 : ret2 + sqr(sum[flag + 1] - sum[now - 1])));
}

stringstream ss;

int main()
{
	freopen("spaceship.in","r",stdin);
	freopen("spaceship.out","w",stdout);
	ios::sync_with_stdio(false);
	ss << cin.rdbuf();
	ss >> n >> k;
	for (int i = 1;i <= n;i++)
	{
		ss >> s[i];
		s[i] *= k;
		avg += s[i];
		sum[i] = sum[i - 1] + s[i];
	}
	avg /= k;
	for (int i = n + 1;i <= 2 * n;i++)
	{
		s[i] = s[i - n];
		sum[i] = sum[i - 1] + s[i];
	}
	ed = n;
	long long limit = get_mid(1) + 1;
	for (int i = 1;i <= limit;i++)
	{
		st = i;
		ed = i + n - 1;
		long long ret = dfs(k,st);
		ans = min(ans,ret + k * avg * avg - 2 * avg * sum[n]);
	}
	cout << ans << endl;
	return 0;
}
