#include <bits/stdc++.h>

#define MAXO 15
#define MAXN 101010
#define MAXINT 2010101010

using namespace std;

int n, m;
int que[MAXN];
char order[MAXO];

void Ans_SmallData ()
{
	int x, y;
	for (int i = 1; i <= m; i ++)
	{
		cin >> order >> x >> y;
		
		if (order[0] == 'i')
		{
			for (int j = n; j >= x; j --)
				que[j + 1] = que[j];
			que[x] = y;
		}
		else if (order[0] == 'm')
		{
			if (order[1] == 'e')
			{
				que[x] = y;
				for (int j = x + 2; j <= n; j ++)
					que[j - 1] = que[j];
				n --;
			}
			else if (order[1] == 'i')
			{
				int mini = MAXINT;
				
				for (int j = x; j < y; j ++)
					for (int k = j + 1; k <= y; k ++)
						if (abs (que[j] - que[k]) < mini)
							mini = abs (que[j] - que[k]);
				cout << mini << endl;
			}
			else if (order[1] == 'a')
			{
				int maxi = 0, mini = MAXINT;
				
				for (int j = x; j <= y; j ++)
				{
					if (que[j] > maxi)
						maxi = que[j];
					if (que[j] < mini)
						mini = que[j];
				}
				cout << maxi - mini << endl;
			}
		}
	}
}

class Node
{
	public :
		int l, r, maxi, mini, minm;
		Node *lch, *rch;
		
		Node (int _l, int _r, int num) :
			l (_l), r (_r), maxi (num), mini (num), minm (MAXINT), lch (NULL), rch (NULL) {}
		
		Node () {}
} *Root;

inline int MaxOf2 (int a, int b)
{
	if (a > b)
		return a;
	else
		return b;
}

inline int MinOf2 (int a, int b)
{
	if (a < b)
		return a;
	else
		return b;
}

void Build_Tree (int le, int re, Node *&now)
{
	if (le == re)
	{
		now = new Node (le, re, que[le]);
		return ;
	}
	
	now = new Node (le, re, 0);
	
	int mid = (le + re) >> 1;
	Build_Tree (le, mid, now->lch);
	Build_Tree (mid + 1, re, now->rch);
	
	now->maxi = MaxOf2 (now->lch->maxi, now->rch->maxi);
	now->mini = MinOf2 (now->lch->mini, now->rch->mini);
	now->minm = MinOf2 (now->lch->minm, now->rch->minm);
	now->minm = MinOf2 (now->minm, abs (que[mid] - que[mid + 1]));
}

int dl, dr;

int Get_AnsOfMin (Node *now)
{
	if (dl <= now->l && dr >= now->r)
		return now->minm;
	
	if (now->r < dl || now->l > dr)
		return MAXINT;
	
	int mid = (now->l + now->r) >> 1;
	if (mid < dl)
		return Get_AnsOfMin (now->rch);
	if (mid + 1 > dr)
		return Get_AnsOfMin (now->lch);
	
	int rec = MinOf2 (Get_AnsOfMin (now->rch), Get_AnsOfMin (now->lch));
	rec = MinOf2 (rec, abs (que[mid] - que[mid + 1]));
	
	return rec;
}

int Get_Maximum (Node *now)
{
	if (dl <= now->l && dr >= now->r)
		return now->maxi;
	
	if (now->r < dl || now->l > dr)
		return 0;
	
	int mid = (now->l + now->r) >> 1;
	if (mid < dl)
		return Get_Maximum (now->rch);
	if (mid > dr)
		return Get_Maximum (now->lch);
	
	return MaxOf2 (Get_Maximum (now->rch), Get_Maximum (now->lch));
}

int Get_Minimum (Node *now)
{
	if (dl <= now->l && dr >= now->r)
		return now->mini;
	
	if (now->r < dl || now->l > dr)
		return MAXINT;
	
	int mid = (now->l + now->r) >> 1;
	if (mid < dl)
		return Get_Minimum (now->rch);
	if (mid > dr)
		return Get_Minimum (now->lch);
	
	return MinOf2 (Get_Minimum (now->rch), Get_Minimum (now->lch));
}

inline int Get_AnsOfMax (Node *now)
{
	return (Get_Maximum (now) - Get_Minimum (now));
}

int main ()
{
	ios::sync_with_stdio (false);
	freopen ("atom.in", "r", stdin);
	freopen ("atom.out", "w", stdout);
	
	cin >> n >> m;
	
	for (int i = 1; i <= n; i ++)
			cin >> que[i];
	
	if (n <= 2000)
	{
		Ans_SmallData ();
	}
	else
	{
		Build_Tree (1, n, Root);
		
		int x, y;
		for (int i = 1; i <= m; i ++)
		{
			cin >> order >> x >> y;
			dl = x, dr = y;
			
			if (order[0] == 'm')
			{
				if (order[1] == 'i')
					cout << Get_AnsOfMin (Root) << endl;
				
				else if (order[1] == 'a')
					cout << Get_AnsOfMax (Root) << endl;
			}
		}
	}
	
	return 0;
}
