#include <bits/stdc++.h>

#define MAXN 301010
#define MAXK 55
#define MAXL 91010101010101010

using namespace std;

int N, K, end;
int len[MAXN];
long long sum, ans, fans = MAXL;
double avr;

void Dfs (int beg, int step)
{
	int s = 0;
	if (step == K)
	{
		for (int i = beg; i <= end; i ++)
			s += len[i];
		ans += s * s;
		
		if (ans < fans)
			fans = ans;
		
		ans -= s * s;
		return ;
	}
	
	for (int i = beg; i <= end; i ++)
	{
		s += len[i];
		if (s > avr)
		{
			ans += s * s;
			Dfs (i + 1, step + 1);
			ans -= s * s;
			
			s -= len[i];
			ans += s * s;
			Dfs (i, step + 1);
			ans -= s * s;
			
			return ;
		}
	}
	
	ans += s * s;
	Dfs (end + 1, step + 1);
	ans -= s * s;
}

int main ()
{
	ios::sync_with_stdio (false);
	freopen ("spaceship.in", "r", stdin);
	freopen ("spaceship.out", "w", stdout);
	
	cin >> N >> K;
	
	for (int i = 1; i <= N; i ++)
	{
		cin >> len[i];
		sum += len[i];
	}
	for (int i = N + 1; i <= N * 2; i ++)
		len[i] = len[i - N];
	
	avr = sum / K;
	
	end = N;
	for (int i = 1; i <= N; i ++)
	{
		Dfs (i, 1);
		end ++;
	}
	
	fans *= K * K;
	fans -= K * sum * sum;
	
	cout << fans << endl;
	
	return 0;
}
