#include <cstdio>

using namespace std;

typedef long long LL;
const int MAXN1 = 300001, MAXN2 = 401;
const int MAXK = 21;

int a[MAXN1];
LL sum[MAXN1];
LL dp[MAXN2][MAXK];
int que[MAXK][MAXN2+1], qh[MAXK], qt[MAXK];
int n, K;
LL ans = 1LL << 60;

void getint(int &x){
	x = 0; char ch;
	while ((ch = getchar()) && (ch < '0' || ch > '9')) ;
	x = ch - '0';
	while ((ch = getchar()) && ch >= '0' && ch <= '9')
		x = x * 10 + ch - '0';
}

void greedy2(){
	LL sa = sum[n] / 2, s = 0; int p = 0;
	for (int i = 1; i <= n; i ++){
		while (s < sa){
			p ++;
			if (p > n) p = 1;
			s += a[p];
		}
		LL c = s * s + (sum[n] - s) * (sum[n] - s);
		if (c < ans) ans = c;
		s -= a[i];
	}
}

void greedy3(){
	LL sa = sum[n] / 3, s1 = 0, s2 = 0;
	int p1 = 1, p2 = 1;
	for (int i = 1; i <= n; i ++){
		s1 -= a[i-1];
		while (s1 + a[(p1-1)%n+1] <= sa){
			s1 += a[(p1-1)%n+1];
			if (p1 < p2) s2 -= a[(p1-1)%n+1];
			p1 ++;
		}
		if (p2 < p1) p2 = p1;
		while (s2 + 2*a[(p2-1)%n+1] <= (sum[n] - s1 - s2)){
			s2 += a[(p2-1)%n+1];
			p2 ++;
		}
		LL c = s1 * s1 + s2 * s2 + (sum[n] - s1 - s2) * (sum[n] - s1 - s2);
		if (c < ans) ans = c;
		LL _s2 = s2 + a[((p2-1)%n+1)];
		c = s1 * s1 + _s2 * _s2 + (sum[n] - s1 - _s2) * (sum[n] - s1 - _s2);
		if (c < ans) ans = c;
	}
}

double fx(int j, int u, int v){
	LL ku = -2*sum[u], bu = sum[u]*sum[u]+dp[u][j];
	LL kv = -2*sum[v], bv = sum[v]*sum[v]+dp[v][j];
	return (bv - bu) * 1.0 / (ku - kv);
}

int main()
{
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	//input
	scanf("%d%d", &n, &K);
	for (int i = 1; i <= n; i ++){
		getint(a[i]);
		sum[i] = sum[i-1] + a[i];
	}
	if (K == 2)//greedy
		greedy2();
	else if (K == 3)
		greedy3();
	else if (n <= 500){//dp: O(kn^3) -> O(kn^2)
		for (int i = 1; i <= n; i ++){//start with i
			//boundary
			dp[i][1] = a[i] * a[i];
			LL si = a[i]; sum[i] = si;
			for (int j = 0; j < K; j ++)
				qh[j] = qt[j] = que[j][0] = 0;
			que[1][++ qt[1]] = i;
			for (int l = 2; l <= n; l ++){
				int t = i+l-1;
				if (t > n) t -= n;
				si += a[t]; sum[t] = si;
				int k = K;
				if (l < k) k = l;
				for (int j = 1; j <= k; j ++){//get states
					int &h = qh[j-1], &ta = qt[j-1], *q = que[j-1];
					while (h < ta && dp[q[h]][j-1]+(si-sum[q[h]])*(si-sum[q[h]]) >= 
							dp[q[h+1]][j-1]+(si-sum[q[h+1]])*(si-sum[q[h+1]]))
						h ++;
					dp[t][j] = dp[q[h]][j-1] + (si-sum[q[h]]) * (si-sum[q[h]]);
				}
				for (int j = 1; j <= k && j < K; j ++){//push states
					int &h = qh[j], &ta = qt[j], *q = que[j];
					q[++ ta] = t;
					while (h+1 < ta && fx(j, q[ta-1], q[ta]) <= fx(j, q[ta-2], q[ta-1]))
						q[-- ta] = t;
				}
			}
			int r = i-1;
			if (i == 1) r = n;
			if (dp[r][K] < ans)
				ans = dp[r][K];
		}
		sum[n] = sum[n-1];
	}
	//output
	ans = (ans * K - sum[n] * sum[n]) * K;
	printf("%lld\n", ans);
	return 0;
}
