#include<iostream>
#include<cstdlib>
#include<cstdio>
#include<cstring>
#include<cmath>

using namespace std;

int N,K;
int S[300010],sum[300010];
double S_avg,S_hal,S_tol;
double ans;
double f[610][610][20];

double div1(int l,int r,int x)
{
	if(l == r) return abs(x-sum[l]);
	if(l+1 == r)
	{
		if(abs(abs(sum[l]-x)-S_hal) < abs(abs(sum[r]-x)-S_hal))
			return abs(sum[l]-x);
		else
			return abs(sum[r]-x);
	}
	int mid = (l+r)/2;
	if(abs(sum[mid]-x) - S_hal < 0)
		return div1(mid,r,x);
	else if(abs(sum[mid]-x) - S_hal == 0)
		return abs(sum[mid]-x);
	else
		return div1(l,mid,x);
}
double div3(int l,int r,int st,int la,int k)
{
	//if(st == 4 && la == 7 && k == 2)
	//	printf("$$ %d $ %d $$\n",l,r);
	if(l == r) return f[st][l][k] + f[l+1][la][1];
	if(l == r+1)
		return min(f[st][l][k]+f[r][la][1],f[st][r][k]+f[r+1][la][1]);
	int mid = (l+r)/2;
	double a=f[st][mid][k]+f[mid+1][la][1],b=f[st][mid+1][k]+f[mid+2][la][1];
	if(a < b)
		return div3(l,mid,st,la,k);
	else
		return div3(mid+1,r,st,la,k);
}

void work1()
{
	ans = 999999999;
	double tmp,ret;
	for(int i=1;i<=N;i++)
	{
		tmp = abs(div1(i,N,sum[i-1]));
		ret = S_tol-tmp;
		tmp = abs(tmp-S_avg);
		ret = abs(ret-S_avg);
		ans = min(ans,(tmp*tmp + ret*ret));
	}
}

int div2(int l,int r,int x)
{
	if(l == r) return l;
	if(l+1 == r)
	{
		if(abs(abs(sum[l]-x)-S_hal) < abs(abs(sum[r]-x)-S_hal))
			return l;
		else
			return r;
	}
	int mid = (l+r)/2;
	if(abs(sum[mid]-x) - S_avg < 0)
		return div2(mid,r,x);
	else if(abs(sum[mid]-x) - S_avg == 0)
		return abs(sum[mid]-x);
	else
		return div2(l,mid,x);
}

void work2()
{
	ans = 999999999;
	double tmp1,tmp2,tmp3;
	int ret1,ret2,ret3;
	for(int i=1;i<=N;i++)
	{
		ret1 = abs(div2(i,N,sum[i-1]));
		ret2 = abs(div2(ret1+1,N,sum[ret1]));
		tmp2 = sum[ret2] - sum[ret1];
		tmp1 = sum[ret1] - sum[i-1];
		tmp3 = S_tol-tmp1-tmp2;
		tmp1 = abs(tmp1-S_avg);
		tmp2 = abs(tmp2-S_avg);
		tmp3 = abs(tmp3-S_avg);
		ans = min(ans,(tmp1*tmp1 + tmp2*tmp2 + tmp3*tmp3));
	}
}
void work3()
{
	double tmp;
	ans = 99999999;
	int i,j,k;
	for(i=1;i<=N;i++)
	{
		S[N+i] = S[i];
		sum[N+i] = sum[i]+sum[N];
	}
	for(k=0;k<=K;k++)
		for(i=0;i<=N;i++)
			for(j=0;j<=N;j++)
				f[i][i+j][k] = 99999999;
	for(i=1;i<=N*2;i++)
		f[i][i][1] = abs(S[i]-S_avg)*abs(S[i]-S_avg);
	for(j=1;j<N;j++)
	{
		for(i=1;i<=N;i++)
		{
			tmp = (double)(sum[i+j]-sum[i-1]) - S_avg;
			f[i][i+j][1] =  tmp*tmp;
		}
		for(i=N+1;i<=N*2;i++)
		{
			if(i+j > N*2) break;
			f[i][i+j][1] = f[i-N][i-N+j][1];
		}
	}
	for(k=2;k<=K;k++)
		for(j=1;j<N;j++)
		{
			for(i=1;i<=N;i++)
			{
				if(i+j > N*2) continue;
				if(j+1 < k)
				{
					f[i][i+j][k] = 99999999;
					continue;
				}
				f[i][i+j][k] = div3(i,min(i+j-1,N),i,i+j,k-1);
			}
			for(i=N+1;i<=N*2;i++)
			{
				if(i+j > N*2) break;
				f[i][i+j][k] = f[i-N][i-N+j][k];
			}
		}
	k = K;
	for(i=1;i<=N;i++)
	{
	//	for(j=0;j<N;j++)
	//	{
			ans = min(ans,f[i][i+N-1][k]);
	//		printf("%lf ",f[i][i+j][k]);
	//	}
	//	printf("\n");
	}
}

int main()
{
	freopen("spaceship.in","r",stdin);
	freopen("spaceship.out","w",stdout);
	scanf("%d%d",&N,&K);
	int i,j,k;
	sum[0] = 0;
	for(i=1;i<=N;i++)
	{
		scanf("%d",&S[i]);
		sum[i] = sum[i-1] + S[i];
	}
	S_avg = (double)(sum[N])/(double)K;
	S_hal = (double)(sum[N])/(double)2;
	S_tol = (double)(sum[N]);
	
//	printf("  ***  %lf  %lf  %lf   ***  \n",S_avg,S_hal,S_tol);
	
	
	if(K == 2)
		work1();
	else if(K == 3 && N > 400)
		work2();
	else
		work3();

	printf("%d\n",int(ans*K*K));
	return 0;
}

/*
5 2
4 2 6 1 3
*/
/*
5 3
4 2 6 1 3
*/
