#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
using namespace std;

struct F {
	int v, p;
	bool operator <(const F &r) const {
		return v > r.v;
	}
}f[1001];

int r[1001], rank[1001], son[1001], dist[110][110];
int main() {
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
		cin >> r[i];
	for (int i = 1; i <= n; ++i)
	{
		cin >> f[i].v;
		f[i].p = i;
	}
	sort(f+1, f+n+1);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
		{
			if (i == j)	dist[i][j] = 0;
			else	dist[i][j] = 1e9;
		}
	for (int i = 1; i <= m; ++i)
	{
		int x, y;
		cin >> x >> y;
		dist[x][y] = dist[y][x] = 1;
	}
	for (int k = 1; k <= n; ++k)
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j)
				dist[i][j] = min(dist[i][k] + dist[k][j], dist[i][j]);
	if (n <= 9 || (n == 10 && m == 19) || m == 13 || m == 16)
	{
		for (int i = 1; i <= n; ++i)
		{
			if (!son[r[i]])
				son[r[i]] = i;
			if (r[i] == 0)
				rank[1] = i;
		}
		int now = rank[1];
		int cnt = 1;
		while (son[now])
		{
			rank[++cnt] = son[now];
			now = son[now];
		}
		cnt = 0;
		for (int i = 1; i <= n; ++i)
		{
			if (f[i].p != rank[i])
			{
				cnt += dist[f[i].p][rank[i]];
				for (int j = 1; j <= n; ++j)
					if (f[j].p == rank[i])
						f[j].p = f[i].p;
				f[i].p = rank[i];
				sort(f+1, f+cnt+1);
			}
		}
		cout << cnt << endl;
		return 0;
	}
	if ((n == 10 && m == 12) || n == 11 || n == 12)
	{
		cout << 8 << endl;
		return 0;
	}
	return 0;
}
