#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#define Rep(i, x, y) for (int i = x; i <= y; i ++)
#define u t[x]
#define o t[y]
#define tc ch[ty]
#define vc ch[!ty]
#define lc ch[0]
#define rc ch[1]
#define Lc t[ u.lc ]
#define Rc t[ u.rc ]
using namespace std;
typedef long long ll;
const int N = 300010, inf = 1 << 30;
int n, T, sz, mx, mn, qz, pz, ro, ql, qr;
char op[9];
struct treap {
	int ch[2], sz, mx, mn, s, z, p; unsigned int w;
	void set(int z0, int p0) {
		mx = mn = z = z0, s = p = p0; sz = 1; w = rand() * rand() * rand(); if (!w) w ++;
	}
} t[N];
void upd(int x) {
	if (!x) return ;
	u.mx = max(u.z, max(Lc.mx, Rc.mx));
	u.mn = min(u.z, min(Lc.mn, Rc.mn));
	u.s = min(Rc.s, min(Lc.s, u.p));
	u.sz = Lc.sz + Rc.sz + 1;
}
void rot(int &x, int ty) {
	int y = u.tc; u.tc = o.vc; o.vc = x; upd(x); upd(x = y);
}
void ins(int &x, int k) {
	if (!x) { t[x = ++ sz].set(qz, abs(qz - pz)); return ; }
	int ty = Lc.sz < k;
	ins(u.tc, k - (Lc.sz + 1) * ty);
	// cout << x<<" "<<u.mn<<" -------- "<<Lc.mn<<" "<<u.lc<< endl;
	t[ u.tc ].w > u.w ? rot(x, ty) : upd(x);
}
void del(int &x, int k) {
	if (Lc.sz + 1 == k || k == -1) {
		int ty = Rc.w > Lc.w;
		if (!u.tc) { x = 0; return ; }
		rot(x, ty);
		del(u.vc, -1); upd(x);
		return ;
	}
	if (Lc.sz >= k) del(u.lc, k);
	else del(u.rc, k - Lc.sz - 1);
	upd(x);
}
void find(int x, int k) {
	if (!k) { pz = inf; return ; }
	// cout << x <<"-"<<k<<"-"<<Lc.sz<<"-"<<Rc.sz<<" "; system("pause");
	if (Lc.sz + 1 == k) { pz = u.z; return ; }
	int ty = Lc.sz < k;
	find(u.tc, k - (Lc.sz + 1) * ty);
}
void qry(int x, int k) {
	if (qr <= k || ql > k + u.sz) return ;
	if (ql <= k + 1 && qr >= k + u.sz) {
		// cout << x<<" - "<<u.lc<<" "<<u.rc<<" - "<<u.sz<<" "<<u.p << endl;
		pz = min(pz, u.s);
		mx = max(u.mx, mx);
		mn = min(u.mn, mn);
		return ;
	}
	if (ql <= k + Lc.sz + 1 && k + Lc.sz < qr) {
		pz = min(pz, u.p);
		mx = max(u.z, mx);
		mn = min(u.z, mn);
	}
	qry(u.lc, k);
	qry(u.rc, k + Lc.sz + 1);
}
int main()
{
	freopen("atom.in", "r", stdin);
	freopen("atom.out", "w", stdout);
	t[0].s = t[0].mn = inf;
	scanf ("%d%d", &n, &T);
	Rep(i, 1, n) {
		pz = qz;
		scanf ("%d", &qz);
		ins(ro, i - 1);
	}
	while (T --) {
		int x, y;
		scanf ("%s%d%d", op, &x, &y);
		qz = y;
		if (op[1] == 'e') {
			del(ro, x), del(ro, x);
			find(ro, x - 1); ins(ro, x - 1);
		} else if (op[1] == 'n') {
			find(ro, x); ins(ro, x);
		} else if (op[1] == 'a') {
			ql = x, qr = y;
			mx = 0, mn = inf;
			qry(ro, 0);
			// cout << mx <<" "<<mn<< endl;
			printf ("%d\n", mx - mn);
		} else {
			ql = x + 1, qr = y;
			pz = inf;
			qry(ro, 0);
			printf ("%d\n", pz);
		}
	//	Rep(i, 1, 5) find(ro, i), printf ("%d ", pz); puts("");
	}
	return 0;
}

