#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#define Rep(i, x, y) for (int i = x; i <= y; i ++)
using namespace std;
typedef long long ll;
typedef double db;
const int N = 300010, inf = 1 << 29;
int n, m, q[N], hd, tl, a[N], n2, t0, t1, t00, t01, t10, t11;
ll s[N], avg, f[405][45], t[N], ans = 1ll << 60;
ll get(int i, int j) {
	return t[j] + s[i] * s[i] - 2 * s[i] * (s[j] + avg) + avg * avg;
}
db slope(int i, int j) {
	return db(t[i] - t[j]) / (s[i] - s[j]);
}
void work2() {
	Rep(j, 1, m) {
		hd = tl = 1; q[1] = 0;
		Rep(i, 1, n) {
			while (hd < tl && get(i, q[hd]) >= get(i, q[hd + 1])) hd ++;
			f[i][j] = get(i, q[hd]);
			// cout << i <<" "<<j<<" "<<f[i][j]<<" "<<hd<<" "<<tl<<" "<<q[hd + 1]<< endl;
			if (j > 1) {
				t[i] = f[i][j - 1] + s[i] * s[i] + 2 * avg * s[i];
				while (hd < tl && slope(q[tl], i) < slope(q[tl - 1], q[tl])) tl --;
				q[++ tl] = i;
			}
		}
	}
	ans = min(ans, f[n][m]);
}
void work0() {
	n2 = n * 2;
	Rep(i, 1, n2) s[i] = s[i - 1] + a[i];
	Rep(i, 1, n) {
		while (s[t0 + 1] - s[i] <= avg) t0 ++;
		while (s[t1] - s[i] <= avg) t1 ++;
		ans = min(ans, abs(s[t0] - s[i] - avg));
		ans = min(ans, abs(s[t1] - s[i] - avg));
	}
	cout << 2 * ans * ans << endl;
}
ll sqr(ll x) { return x * x; }
void work1() {
	n2 = n * 2;
	Rep(i, 1, n2) s[i] = s[i - 1] + a[i];
	Rep(i, 1, n) {
		while (s[t0 + 1] - s[i] <= avg) t0 ++;
		while (s[t1] - s[i] <= avg) t1 ++;
		while (s[t00 + 1] - s[t0] <= avg) t00 ++;
		while (s[t01] - s[t0] <= avg) t01 ++;
		while (s[t10 + 1] - s[t1] <= avg) t10 ++;
		while (s[t11] - s[t1] <= avg) t11 ++;
		ans = min(ans, sqr(s[t0] - s[i] - avg) + sqr(s[t00] - s[t0] - avg) + sqr(s[n + i] - s[t00] - avg));
		ans = min(ans, sqr(s[t0] - s[i] - avg) + sqr(s[t01] - s[t0] - avg) + sqr(s[n + i] - s[t01] - avg));
		ans = min(ans, sqr(s[t1] - s[i] - avg) + sqr(s[t10] - s[t1] - avg) + sqr(s[n + i] - s[t10] - avg));
		ans = min(ans, sqr(s[t1] - s[i] - avg) + sqr(s[t11] - s[t1] - avg) + sqr(s[n + i] - s[t11] - avg));
	}
	cout << ans << endl;
}
int main()
{
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	scanf ("%d%d", &n, &m);
	Rep(i, 1, n) {
		scanf ("%d", &a[i]);
		avg += a[i];
		a[n + i] = a[i] = a[i] * m;
	}
	a[n * 2 + 1] = inf;
	if (n <= 400) {
		Rep(i, 1, n) {
			Rep(j, 1, n) s[j] = s[j - 1] + a[(i + j) % n + 1]; // cout << s[j]<<" ";
			// puts("");
			work2();
		}
		cout << ans << endl;
	} else if (m == 2) work0();
	else work1();
	return 0;
}

