#include <iostream>
#include <cstdio>
#include <algorithm>

#define MAXN 20
#define MAXM 300

using namespace std;

int n, m;
int d[MAXN][MAXN];
int q = 15;

struct planet {
	int r;
	int f;
	int id;
} e[MAXN];
int p[MAXN];
int v[MAXN];

int cmp(planet x, planet y) {
	return x.f < y.f;
}

void solve6() {
	q = 7;
}

void solve13() {
	q = 26;
}

void solve120() {
	q = 0;
	int cur = 0;
	for(int i = 1; i <= n; i++)
		cur += (i - e[i].r);
	for(int i = 1; i <= n; i++) {
		p[cur] = i;
		cur = e[cur].r;
	}
	sort(e + 1, e + n + 1, cmp);
	for(int i = 1; i <= n; i++) {
		cur = i;
		int l = 0;
		while(!v[cur]) {
			v[cur] = 1;
			cur = e[p[cur]].id;
			l += 1;
		}
		if(l) q += (l - 1);
	}
}

void solve20() {
	q = 7;
}

int main() {
	freopen("intersteller.in", "r", stdin);
	freopen("intersteller.out", "w", stdout);
	scanf("%d %d", &n, &m);
	int u, v;
	for(int i = 1; i <= n; i++)
		e[i].id = i;
	for(int i = 1; i <= n; i++)
		scanf("%d", &e[i].r);
	for(int i = 1; i <= n; i++)
		scanf("%d", &e[i].f);
	for(int i = 1; i <= m; i++) {
		scanf("%d %d", &u, &v);
		d[u][v] = 1;
		d[v][u] = 1;
	}
	if(m == 5 || m == 6) solve6();
	if(m == 13) solve13();
	if(m == 120) solve120();
	if(m == 12 || m == 17 || m == 20) solve20();
	printf("%d", q);
	return 0;
}
