#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
using namespace std;
int a[101010];
struct Node
{
	int l,r;
	Node *lch,*rch;
	int min_ans;
	int min_num,max_num;
}*root;
void Build(Node *&root,int l,int r)
{
	root=new Node;
	root->l=l;
	root->r=r;
	if(l==r)
	{
		root->min_ans=a[r];
		root->min_num=a[l];
		root->max_num=a[r];
		return;
	}
	int mid=(l+r)>>1;
	Build(root->lch,l,mid);
	Build(root->rch,mid+1,r);
	root->max_num=max(root->lch->max_num,root->rch->max_num);
	root->min_num=min(root->lch->min_num,root->rch->min_num);
	if(l+1==r)
		root->min_ans=abs(a[r]-a[l]);
	else
		root->min_ans=min(root->lch->min_ans,min(root->rch->min_ans,abs(a[mid+1]-a[mid])));
}
int query_max_num(Node *root,int l,int r)
{
	if(l<=root->l&&r>=root->r)
		return root->max_num;
	int mid=(root->l+root->r)>>1;
	int ans=0;
	if(r>mid)
		ans=max(ans,query_max_num(root->rch,l,r));
	if(l<=mid)
		ans=max(ans,query_max_num(root->lch,l,r));
	return ans;
}
int query_min_num(Node *root,int l,int r)
{
	if(l<=root->l&&r>=root->r)
		return root->min_num;
	int mid=(root->l+root->r)>>1;
	int ans=10101010;
	if(r>mid)
		ans=min(ans,query_min_num(root->rch,l,r));
	if(l<=mid)
		ans=min(ans,query_min_num(root->lch,l,r));
	return ans;
}
int query_min(Node *root,int l,int r)
{
	if(l<=root->l&&r>=root->r)
		return root->min_ans;
	int mid=(root->l+root->r)>>1;
	int ans_left=0,ans_right=0;
	if(r>=mid)
	{
		if(l!=mid)
			ans_left=query_min(root->lch,l,r);
		else
			ans_left=abs(a[l+1]-a[l]);
	}
	if(l<=mid+1)
	{
		if(r!=mid+1)
			ans_right=query_min(root->rch,l,r);
		else
		 	ans_right=abs(a[r]-a[r-1]);
	}
	return min(ans_left,ans_right);
}
int main()
{
	std::ios::sync_with_stdio(false);
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	int n,m;
	cin>>n>>m;
	for(int i=1;i<=n;i++)
		cin>>a[i];
	if(n<=1000)
	{
		while(m--)
		{
			string op;
			int x,y;
			cin>>op>>x>>y;
			if(op=="max")
			{
				int max1=-1,min1=10101010;
				for(int i=x;i<=y;i++)
				{
					max1=max(max1,a[i]);
					min1=min(min1,a[i]);
				}
				cout<<max1-min1<<endl;
			}
			else if(op=="min")
			{
				int ans=10101010;
				for(int i=x;i<y;i++)
					ans=min(ans,abs(a[i+1]-a[i]));
				cout<<ans<<endl;
			}
			else if(op=="insert")
			{
				for(int i=n;i>x;i--)
					a[i+1]=a[i];
				a[x]=y;
				n++;
			}
			else
			{
				a[x]=y;
				for(int i=x+1;i<=n;i++)
					a[i]=a[i+1];
				n--;
			}
		}
		return 0;
	}
	Build(root,1,n);
	while(m--)
	{
		string op;
		int x,y;
		cin>>op>>x>>y;
		if(op=="max")
		{
			int tmp1=query_max_num(root,x,y);
			int tmp2=query_min_num(root,x,y);
			cout<<tmp1-tmp2<<endl;
		}
		else if(op=="min")
		{
			cout<<query_min(root,x,y)<<endl;
		}
		else if(op=="insert")
		{
			for(int i=n;i>x;i--)
				a[i+1]=a[i];
			a[x]=y;
			n++;
			Build(root,1,n);
		}
		else
		{
			a[x]=y;
			for(int i=x+1;i<=n;i++)
				a[i]=a[i+1];
			n--;
			Build(root,1,n);
		}
	}
	return 0;
}
