#include<cstdio>
#include<iostream>
#include<cstdlib>
#define inf 2147483600
using namespace std;
const int N=210000;
int n,m,root,cnt,in[N];
char c[10];
int parent[N],ch[N][2],size[N],    v[N],dl[N],dr[N],      mx[N],mn[N],dmn[N];
int side(int x){return ch[parent[x]][1]==x;}
void pushup(int x)
{
	size[0]=0;
    size[x]=1+size[ch[x][0]]+size[ch[x][1]];
    mx[x]=max(v[x],max(ch[x][0]==0?-inf:mx[ch[x][0]],ch[x][1]==0?-inf:mx[ch[x][1]]));
    mn[x]=min(v[x],min(ch[x][0]==0?inf:mn[ch[x][0]],ch[x][1]==0?inf:mn[ch[x][1]]));
    dmn[x]=min(dl[x],dr[x]);
    if(ch[x][0]) dmn[x]=min(dmn[x],dmn[ch[x][0]]);
	if(ch[x][1]) dmn[x]=min(dmn[x],dmn[ch[x][1]]);
}
void rotate(int x)
{
    int p=parent[x],g=parent[p],d=side(x),d1=side(p),son=ch[x][d^1];
    if(g) ch[g][d1]=x; parent[x]=g;
    ch[x][d^1]=p; parent[p]=x;
    ch[p][d]=son;  if(son) parent[son]=p;
    if(root==p) root=x;
    pushup(p);pushup(x);
}
void splay(int x,int goal)
{
    for(;parent[x]!=goal;rotate(x))
        if(parent[parent[x]]!=goal)
            if(side(x)==side(parent[x])) rotate(parent[x]);
            else rotate(x);
}

int kth(int x,int k)
{
    if(size[ch[x][0]]==k-1) return x;
    else if(size[ch[x][0]]>k-1) return kth(ch[x][0],k);
    else return kth(ch[x][1],k-size[ch[x][0]]-1);

}

void insert(int k,int val)
{
    int t1=kth(root,k),t2=kth(root,k+1);
    splay(t1,0),splay(t2,t1);
    int x=++cnt;
    mx[x]=mn[x]=v[x]=val,size[x]=1;	
    parent[x]=t2;ch[t2][0]=x;
    
    dr[t1]=dl[x]=abs(val-v[t1]),
    dl[t2]=dr[x]=abs(val-v[t2]);
    dmn[x]=min(dl[x],dr[x]);
    
    pushup(t2);pushup(t1);
}

void merge(int x,int val)
{
	int u=kth(root,x+1);
    splay(kth(root,x),0),splay(u,root);
	int l=kth(root,x-1),r=kth(root,x+2);
	splay(l,root),splay(r,u);
	parent[ch[u][1]]=root;ch[root][1]=ch[u][1];
	
	v[root]=val;
	dl[root]=dr[l]=abs(val-v[l]);
	dr[root]=dl[r]=abs(val-v[r]);
	pushup(r); pushup(l); pushup(root);
}

int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	scanf("%d%d",&n,&m);
	int l=++cnt,r=++cnt;
	v[l]=inf,size[l]=2,mx[l]=-inf,mn[l]=inf,dmn[l]=inf,dl[l]=inf,dr[l]=inf;
	v[r]=inf,size[r]=1,mx[r]=-inf,mn[r]=inf,dmn[r]=inf,dl[r]=inf,dr[r]=inf;
	
	root=l;ch[l][1]=r;parent[r]=l;
	
	for(int i=1,x;i<=n;i++) scanf("%d",&x),insert(i,x);
	
	
    for(int i=1,x,y;i<=m;i++)
    {
	    scanf("%s%d%d",c,&x,&y);//insert merge max min
	    x++,y++;
		
	    int tmp,ans;
	    if(c[1]=='a') 
		    splay(kth(root,x-1),0), splay(kth(root,y+1),root),
			tmp=ch[ch[root][1]][0],
			printf("%d\n",mx[tmp]-mn[tmp]);
			
	    if(c[1]=='i')
	        if(y-x==1) printf("%d\n",dl[kth(root,y)]);
	        else 
	            splay(kth(root,x),0),splay(kth(root,y),root),
	            tmp=ch[ch[root][1]][0],
	            printf("%d\n",dmn[tmp]);
          
	    if(c[1]=='n')
	        y--,insert(x,y);
	    if(c[1]=='e')
	    	y--,merge(x,y);      
	}
}

