#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string.h>
#define MAXN 100010
using namespace std;
int n,m,cnt,cnt2,ans;
int d[2*MAXN];
struct node 
{
	int max,min,smax;
	node *lson,*rson;
}pool[20*MAXN],*root;
void work1()
{
	for (int i=1;i<=m;i++) {
		char c[10];int a,b;
		scanf("%s%d%d",c,&a,&b);
		if (c[1] == 'i'){
			//cout<<"Min"<<endl;
			int tmp[1001];
			for (int i=a;i<=b;i++) tmp[i-a+1] = d[i];
			sort(tmp+1,tmp+b-a+2);
			ans = tmp[b-a+1] - tmp[b-a];
			memset(tmp,0,sizeof(tmp));
			printf("%d\n",ans);
		}
		if (c[1] == 'a'){
			//cout<<"Max"<<endl;
			int MAX = -1,MIN = INT_MAX;
			for (int i=a;i<=b;i++) {
				if (d[i]>MAX) MAX = d[i];
				if (MIN>d[i]) MIN = d[i]; 
			}
			ans = MAX - MIN;
			printf("%d\n",ans);
		}
		if (c[0] == 'i'){
			for (int i=n;i>a;i--) d[i+1] = d[i];
			d[a+1] = b;
			n++;
		}
		if (c[1] == 'e'){
			for (int i=a+1;i<n;i++) d[i] = d[i+1];
			d[a] = b;
			n--;
		}
	}
}
void Update(node *p)
{
	int mx[5];
	mx[1] = p->lson->max;mx[3] = p->rson->max;
	mx[2] = p->lson->smax;mx[4] = p->rson->smax;
	sort(mx+1,mx+5);
	p->max = mx[4];
	p->smax = mx[3];
	p->min = min(p->lson->min,p->rson->min);
	
}
void Build(node *p,int left,int right)
{
	if (left == right) {
		p->max = p->min = d[left];
		p->smax = 0;
		return;
	}
	p->lson = &pool[++cnt];
	p->rson = &pool[++cnt];
	int mid = (left+right) >>1;
	Build(p->lson,left,mid);
	Build(p->rson,mid+1,right);
	Update(p);
}
int Querymax(node *p,int left,int right,int l,int r)
{
	if (left == l && right == r) return p->max;
	int mid = (left+right) >>1;
	if (l>=mid+1) return Querymax(p->rson,mid+1,right,l,r);
	if (mid>=r) return Querymax(p->lson,left,mid,l,r);
	else {
		return max(Querymax(p->lson,left,mid,l,mid),
				   Querymax(p->rson,mid+1,right,mid+1,r));
	}
}
int Querysmax(node *p,int left,int right,int l,int r)
{
	if (left == l && right == r) return p->smax;
	int mid = (left+right) >>1;
	if (l>=mid+1) return Querysmax(p->rson,mid+1,right,l,r);
	if (mid>=r) return Querysmax(p->lson,left,mid,l,r);
	else {
		int mx[5];
		mx[1] = Querymax(p->lson,left,mid,l,mid);mx[3] = Querymax(p->rson,mid+1,right,mid+1,r);
	 	mx[2] = Querysmax(p->lson,left,mid,l,mid);mx[4] = Querysmax(p->rson,mid+1,right,mid+1,r);
		sort(mx+1,mx+5);
		return mx[3];
	}
}
int Querymin(node *p,int left,int right,int l,int r)
{
	if (left == l && right == r) return p->min;
	int mid = (left+right) >>1;
	if (l>=mid+1) return Querymin(p->rson,mid+1,right,l,r);
	if (mid>=r) return Querymin(p->lson,left,mid,l,r);
	else {
		return min(Querymin(p->lson,left,mid,l,mid),
				   Querymin(p->rson,mid+1,right,mid+1,r));
	}
}
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	scanf("%d%d",&n,&m);
	for (int i=1;i<=n;i++) scanf("%d",&d[i]);	
	if (n<=1000) work1();
	else{
		root = &pool[++cnt];
		Build(root,1,n);
		for (int i=1;i<=m;i++){
			char c[10]; int a,b;
			scanf("%s%d%d",c,&a,&b);
			if (c[1] == 'i') printf("%d\n",Querymax(root,1,n,a,b) - Querysmax(root,1,n,a,b));
			if (c[1] == 'a') printf("%d\n",Querymax(root,1,n,a,b) - Querymin(root,1,n,a,b));
		}
	}
	return 0;
}
