#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>

using namespace std;

const long long oo = 1e15;
long long n, m, sum = 0, ans = oo, a[301010], s[301010], f[405][22];

void force1() {
	long long now = 0;
	for (int i = 0; i < n; ++i)
		a[i+n] = a[i];
	a[n+n] = oo;
	for (int i = 0, p = 0; i < n; ++i) {
		if (i >= p)
			now += a[p++];
		while (now + a[p] <= sum / 2)
			now += a[p++];
		ans = min(ans, now*now+(sum-now)*(sum-now));
		now -= a[i];
	}
}

void force2() {
	for (int i = 0; i < n; ++i) {
		s[0] = 0;
		for (int j = 0; j < n; ++j)
			s[j+1] = s[j] + a[j];
		for (int j = 0; j <= n; ++j)
			for (int k = 0; k <= m; ++k)
				f[j][k] = oo;
		f[0][0] = 0;
		for (int j = 0; j < n; ++j)
			for (int k = 0; k < m; ++k)
				if (f[j][k] != oo)
					for (int p = j+1; p <= n; ++p)
						f[p][k+1] = min(f[p][k+1], f[j][k]+(s[p]-s[j])*(s[p]-s[j]));
		ans = min(ans, f[n][m]);
		a[n] = a[0];
		for (int j = 0; j < n; ++j)
			a[j] = a[j+1];
	}
}

void greed1() {
	for (int i = 0; i < n; ++i) {
		long long now = 0;
		s[0] = 0;
		for (int j = 0; j < n; ++j)
			s[j+1] = s[j] + a[j];
		s[n+1] = oo;
		for (int j = 1, k = 0, cnt = 1; j <= n; ++j) {
			long long s1 = s[j] - s[k], s2 = s[j+1] - s[k];
			if (n - j == m - cnt || (cnt != m || j == n) && m*(s1*s1-s2*s2)+2*sum*(s2-s1) <= 0)
				now += (s[j]-s[k])*(s[j]-s[k]), k = j, ++cnt;
		}
		ans = min(ans, now);
		a[n] = a[0];
		for (int j = 0; j < n; ++j)
			a[j] = a[j+1];
	}
}

void greed2() {
	int k = n / 3;
	s[0] = 0;
	for (int j = 0; j < n; ++j)
		s[j+1] = s[j] + a[j];
	ans = s[k]*s[k] + (s[k*2]-s[k])*(s[k*2]-s[k]) + (s[n]-s[k*2])*(s[n]-s[k*2]);
}

int main() {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	ios::sync_with_stdio(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		cin >> a[i], sum += a[i];
	if (m == 2)
		force1();
	else if (n <= 200)
		force2();
	else if (n <= 400)
		greed1();
	else
		greed2();
	ans *= m * m;
	ans -= m * sum * sum;
	cout << ans << endl;
	return 0;
}
