//meowmeowmeow
#include <stdio.h>
#include <algorithm>
#include <string.h>

using namespace std;

const int maxn = 220000;
struct node {
	int x , siz;
	int maxx , minn;
	node *ch[4] , *fa;
} pool1[maxn*3] , *root1 , pool2[maxn*5] , *root2;
int top1 , top2;
int n , m;
int a[maxn];
void output ( node *id ) {
	if ( id -> ch[0] ) output ( id -> ch[0] );
	printf ( "%d ls%d rs%d fa%d x%d siz%d maxx%d minn%d\n"  , id , id -> ch[0] , id -> ch[1] , id -> fa , id -> x , id -> siz , id -> maxx , id -> minn );
	if ( id -> ch[1] ) output ( id -> ch[1] );
}
void update ( node *id ) {
	id -> siz = 1; id -> minn = id -> maxx = id -> x;
	if ( id -> ch[0] ) {
		id -> siz += id -> ch[0] -> siz;
		id -> minn = min ( id -> minn , id -> ch[0] -> minn );
		id -> maxx = max ( id -> maxx , id -> ch[0] -> maxx );
	}
	if ( id -> ch[1] ) {
		id -> siz += id -> ch[1] -> siz;
		id -> minn = min ( id -> minn , id -> ch[1] -> minn );
		id -> maxx = max ( id -> maxx , id -> ch[1] -> maxx );
	}
}
void rotate ( node *id , int kind ) {
	node *y = id -> fa;
	if ( y -> fa ) y -> fa -> ch[y==y->fa->ch[1]] = id;
	id -> fa = y -> fa;
	y -> ch[kind] = id -> ch[1-kind];
	if ( id -> ch[1-kind] ) id -> ch[1-kind] -> fa = y;
	id -> ch[1-kind] = y;
	y -> fa = id;
	update ( y ); update ( id );
}
void splay ( node *id , node *fa , int kind ) {
	for ( ; id -> fa != fa ; rotate ( id , id==id->fa->ch[1] ) )
		if ( id -> fa -> fa != fa && (id==id->fa->ch[1]) == (id->fa==id->fa->fa->ch[1]) )
			rotate ( id -> fa , id==id->fa->ch[1] );
	if ( fa == NULL ) {
		if ( kind == 1 ) root1 = id;
		else root2 = id;
	}
}
node *find ( node *id , int x ) {
	int s = 0;
	//printf ( "%d %d\n" , id , x );
	if ( id -> ch[0] ) s += id -> ch[0] -> siz;
	if ( s >= x ) return find ( id -> ch[0] , x );
	else {
		if ( s + 1 == x ) return id;
		else return find ( id -> ch[1] , x - s - 1 );
	}
}
void delete2 ( int x ) {
	splay ( find ( root2 , x - 1 ) , NULL , 2 );
	splay ( find ( root2 , x + 1 ) , root2 , 2 );
	root2 -> ch[1] -> ch[0] = NULL;
	update ( root2 -> ch[1] ); update ( root2 );
}
void add2 ( int x , int y ) {
	splay ( find ( root2 , x ) , NULL , 2 );
	splay ( find ( root2 , x + 1 ) , root2 , 2 );
	root2 -> ch[1] -> ch[0] = &pool2[++top2];
	root2 -> ch[1] -> ch[0] -> x = y;
	root2 -> ch[1] -> ch[0] -> fa = root2 -> ch[1];
	update ( root2 -> ch[1] -> ch[0] ); update ( root2 -> ch[1] );
	update ( root2 );
}
void work () {
	int i , x , y , now1 , now2;
	char op[20];
	scanf ( "%d%d" , &n , &m );
	root1 = &pool1[0]; root2 = &pool2[0];
	pool1[0].x = -1;
	pool1[0].siz = n + 2;
	pool1[0].ch[1] = &pool1[1];
	for ( i = 1 ; i <= n ; i++ ) {
		scanf ( "%d" , &a[i] );
		pool1[i].x = a[i];
		pool1[i].siz = n + 2 - i;
		pool1[i].ch[1] = &pool1[i+1];
		pool1[i].fa = &pool1[i-1];
	}
	pool1[n+1].x = -1;
	pool1[n+1].siz = 1;
	pool1[n+1].fa = &pool1[n];
	top1 = n + 1;
	pool2[0].x = -1;
	pool2[0].siz = n + 1;
	pool2[0].ch[1] = &pool2[1];
	for ( i = 1 ; i < n ; i++ ) {
		pool2[i].x = abs ( a[i] - a[i+1] );
		pool2[i].siz = n + 1 - i;
		pool2[i].ch[1] = &pool2[i+1];
		pool2[i].fa = &pool2[i-1];
	}
	pool2[n].x = -1;
	pool2[n].siz = 1;
	pool2[n].fa = &pool2[n-1];
	top2 = n;
	for ( i = 1 ; i <= m ; i++ ) {
		scanf ( "%s%d%d" , op + 1 , &x , &y );
		if ( strcmp ( op + 1 , "merge" ) == 0 ) {
			//panduan
			if ( x != 1 ) now1 = find ( root1 , x ) -> x;
			if ( x != n - 1 ) now2 = find ( root1 , x + 3 ) -> x;
			if ( x != n - 1 ) delete2 ( x + 2 );
			delete2 ( x + 1 );
			if ( x != 1 ) delete2 ( x );
			if ( x != 1 ) add2 ( x - 1 , abs(now1 - y) );
			if ( x != n - 1 ) add2 ( x , abs(y - now2) );
			//output ( root1 );
			//printf ( "\n" );
			//printf ( "%d %d %d\n" , now1 , now2 );
			splay ( find ( root1 , x + 1 ) , NULL , 1 );
			splay ( find ( root1 , x + 3 ) , root1 , 1 );
			root1 -> ch[1] -> ch[0] = NULL;
			update ( root1 -> ch[1] ); update ( root1 );
			root1 -> x = y;
			update ( root1 );
			n--;
		}
		if ( strcmp ( op + 1 , "insert" ) == 0 ) {
			splay ( find ( root1 , x + 1 ) , NULL , 1 );
			splay ( find ( root1 , x + 2 ) , root1 , 1 );
			top1++;
			pool1[top1].x = y; pool1[top1].siz = 1;
			pool1[top1].fa = root1 -> ch[1]; root1 -> ch[1] -> ch[0] = &pool1[top1];
			update ( root1 -> ch[1] -> ch[0] ); update ( root1 -> ch[1] );
			update ( root1 );
			now1 = root1 -> x; now2 = root1 -> ch[1] -> x;
			//printf ( "%d %d\n" , n , now2 );
			if ( x != n ) delete2 ( x + 1 );
			add2 ( x , abs ( now1 - y ) );
			if ( x != n ) add2 ( x + 1 , abs ( y - now2 ) );
			n++;
		}
		if ( strcmp ( op + 1 , "max" ) == 0 ) {
			//printf ( "%d\n" , find ( root1 , x ) );
			splay ( find ( root1 , x ) , NULL , 1 );
			splay ( find ( root1 , y + 2 ) , root1 , 1 );
			printf ( "%d\n" , root1 -> ch[1] -> ch[0] -> maxx - root1 -> ch[1] -> ch[0] -> minn );
		}
		if ( strcmp ( op + 1 , "min" ) == 0 ) {
			splay ( find ( root2 , x ) , NULL , 2 );
			splay ( find ( root2 , y + 1 ) , root2 , 1 );
			printf ( "%d\n" , root2 -> ch[1] -> ch[0] -> minn );
		}
	}
}
int main () {
	FILE *fpr = freopen ( "atom.in" , "r" , stdin );
	FILE *fpw = freopen ( "atom.out" , "w" , stdout );
	work ();
	return 0;
}
