#include <stdio.h>
#include <algorithm>

using namespace std;

const int maxn = 20;
const int maxm = 1200;
struct node {
	int v;
	node *next;
} pool[maxm] , *g[maxn];
int top;
int n , m;
int fa[maxn] , a[maxn];
int dep[maxn];
int u[maxm] , v[maxm];
int ans;
int root;
void add ( int u , int v ) {
	node *tmp = &pool[++top];
	tmp -> v = v; tmp -> next = g[u]; g[u] = tmp;
}
void dfs1 ( int i , int from ) {
	for ( node *j = g[i] ; j ; j = j -> next ) if ( j -> v != from ) {
		dep[j->v] = dep[i] + 1;
		dfs1 ( j -> v , i );
	}
}
void dfs2 ( int x ) {
	if ( x > 14 ) {
		return ;
	}
	if ( x > ans ) return ;
	int i , f = 1;
	for ( i = 1 ; i <= n ; i++ ) if ( i != root && a[i] > a[fa[i]] ) f = 0;
	if ( f == 1 ) {
		ans = min ( ans , x - 1 );
		return ;
	}
	for ( i = 1 ; i <= m ; i++ ) {
		//if ( a[u[i]] < a[v[i]] ) {
			swap ( a[u[i]] , a[v[i]] );
			dfs2 ( x + 1 );
			swap ( a[u[i]] , a[v[i]] );
		//}
	}
}
void work () {
	int i;
	scanf ( "%d %d" , &n , &m );
	for ( i = 1 ; i <= n ; i++ ) {
		scanf ( "%d" , &fa[i] );
		if ( fa[i] != 0 ) {
			add ( i , fa[i] );
			add ( fa[i] , i );
		}
		else root = i;
	}
	dep[root] = 1;
	dfs1 ( root , -1 );
	for ( i = 1 ; i <= n ; i++ ) scanf ( "%d" , &a[i] );
	for ( i = 1 ; i <= m ; i++ ) {
		scanf ( "%d%d" , &u[i] , &v[i] );
		if ( dep[u[i]] > dep[v[i]] ) swap ( u[i] , v[i] );
	}
	ans = 999999;
	dfs2 ( 1 );
	printf ( "%d\n" , ans );
}
int main () {
	FILE *fpr = freopen ( "interstellar.in" , "r" , stdin );
	FILE *fpw = freopen ( "interstellar.out" , "w" , stdout );
	work ();
	return 0;
}
