#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <algorithm>
using namespace std;
const int oo = 1010101010;
struct edges
{
	int to, next;
}edgem[300], edget[25];
int pointm[25], tem = -1;
void addm(int a, int b)
{
	tem ++;
	edgem[tem].to = b;
	edgem[tem].next = pointm[a];
	pointm[a] = tem;
}
int pointt[25], tet = -1;
void addt(int a, int b)
{
	tet ++;
	edget[tet].to = b;
	edget[tet].next = pointt[a];
	pointt[a] = tet;
}
int n, m;
int par[25], v[25];
int root;
int dis[25][25];
int ans = 0;
void dfs(int now)
{
//	cout << now << endl;
	int mx = 0, c;
	for(int i = 1; i <= n; i ++)
		if(v[i] > mx)
		{
			mx = v[i];
			c = i;
		}
	v[c] = 0;
	ans += dis[now][c];
	swap(v[now], v[c]);
//	cout << now << " " << c << endl;
	for(int e = pointt[now]; e != -1; e = edget[e].next)
		dfs(edget[e].to);
}
int main()
{
	freopen("interstellar.in", "r", stdin);
	freopen("interstellar.out", "w", stdout);
	std::ios::sync_with_stdio(false);
	memset(pointm, -1, sizeof(pointm));
	memset(pointt, -1, sizeof(pointt));
	cin >> n >> m;
	for(int i = 1; i <= n; i ++)
		for(int j = 1; j <= n; j ++)
			dis[i][j] = oo;
	for(int i = 1; i <= n; i ++)
	{
		cin >> par[i];
		if(par[i] != 0)
			addt(par[i], i);
		else
			root = i;
	}
	for(int i = 1; i <= n; i ++)
	{
		cin >> v[i];
		dis[i][i] = 0;
	}
	for(int i = 1; i <= m; i ++)
	{
		int a, b;
		cin >> a >> b;
		addm(a, b);
		addm(b, a);
		dis[a][b] = 1;
		dis[b][a] = 1;
	}
	/*
	for(int i = 1;i <= n; i ++)
	{
		for(int j = 1;j <= n; j ++)
			cout << dis[i][j] << " ";
		cout << endl;
	}
	*/
	for(int k = 1; k <= n; k ++)
		for(int i = 1; i <= n; i ++)
			for(int j = 1; j <= n; j ++)
				dis[i][j] = min(dis[i][k] + dis[k][j], dis[i][j]);
	/*
	for(int i = 1; i <= n; i ++)
	{
		for(int j = 1; j <= n; j ++)
			cout << dis[i][j] << " ";
		cout << endl;
	}
	*/
	/*
	for(int i = 1; i <= n; i ++)
	{
		cout << i << ":" << endl;
		for(int e = pointt[i]; e != -1; e = edget[e].next)
			cout << edget[e].to << " " ;
		cout << endl;
	}
	*/
	dfs(root);
	cout << ans << endl;
	return 0;
}
/*
4 4
0 1 2 3
1 2 3 4
1 2
1 4
2 3
1 3
 */
