#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <set>

using namespace std;

const int INF = 1 << 30;
const int MAXN = 2005;

int n, m, E, x, y, e;

string s;

int a[MAXN];

int main() {
	ios::sync_with_stdio(false);
	freopen("autom.in", "r", stdin);
	freopen("autom.out", "w", stdout);
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		cin >> E;
		a[i] = E;
	}
	for (int i = 1; i <= m; i++) {
		cin >> s;
		if (s == "merge") {
			cin >> x >> e;
			n--;
			for (int j = x + 1; j <= n; j++)
				a[j] = a[j + 1];
		}
		else if (s == "insert") {
			cin >> x >> e;
			n++;
			for (int j = n; j > x + 1; j--)
				a[j] = a[j - 1];
			a[x + 1] = e;
		}
		else if (s == "max") {
			cin >> x >> y;
			int Max = 0;
			int Min = INF;
			for (int j = x; j <= y; j++) {
				Min = min(Min, a[j]);
				Max = max(Max, a[j]);
			}
			cout << Max - Min << endl;
		}
		else if (s == "min") {
			cin >> x >> y;
			long long res = 1ll << 60;
			set<long long> s;
			set<long long>::iterator it;
			s.insert(-1ll << 60);
			s.insert(1ll << 60);
			for (int j = x; j <= y; j++) {
				it = s.lower_bound(a[j]);
				res = min(res, *it - a[j]);
				it--;
				res = min(res, a[j] - *it);
				s.insert(a[j]);
			}
			cout << res << endl;
		}
	}
	return 0;
}

