#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <string>
#include <algorithm>

using namespace std;

long long n, k;

long long l[700005];
long long lq[700005] = {0};

long long f[505][505][30];
long long sum = 0;
long long ans;

long long clac(long long len){
	return len * len * k * k - 2 * len * sum * k + sum * sum;
}

int dfs(int x, int y, int c){
	int i, j;
	f[x][y][c] = 100000000007;
	
	if(c == 1){
		if(y >= x){
			f[x][y][c] = clac(lq[y] - lq[x - 1]);
			return 0;
		}else{
			f[x][y][c] = clac(lq[y] + lq[n] - lq[x - 1]);
			return 0;
		}
	}
	
	if(y >= x){
		for(i=x;i<y;i++){
			for(j=1;j<c;j++){
				if(j > i - x + 1 or c - j > y - i){
					continue;
				}else{
					if(f[x][i][j] == -1){
						dfs(x, i, j);
					}
					
					if(f[i + 1][y][c - j] == -1){
						dfs(i + 1, y, c - j);
					}
					
					f[x][y][c] = min(f[x][y][c], f[x][i][j] + f[i + 1][y][c - j]);
				}
			}
		}
	}else{
		//i < n
		for(i=x;i<n;i++){
			for(j=1;j<c;j++){
				if(j > i - x + 1 or c - j > y + n - i){
					continue;
				}else{
					if(f[x][i][j] == -1){
						dfs(x, i, j);
					}
					
					if(f[i + 1][y][c - j] == -1){
						dfs(i + 1, y, c - j);
					}
					
					f[x][y][c] = min(f[x][y][c], f[x][i][j] + f[i + 1][y][c - j]);
				}
			}
		}
		
		//i == n
		for(j=1;j<c;j++){
			if(j > n - x + 1 or c - j > y){
				continue;
			}else{
				if(f[x][n][j] == -1){
					dfs(x, n, j);
				}
					
				if(f[1][y][c - j] == -1){
					dfs(1, y, c - j);
				}
					
				f[x][y][c] = min(f[x][y][c], f[x][n][j] + f[1][y][c - j]);
			}
		}
		
		//i -> 1
		for(i=1;i<y;i++){
			for(j=1;j<c;j++){
				if(j > i + n - x + 1 or c - j > y - i){
					continue;
				}else{
					if(f[x][i][j] == -1){
						dfs(x, i, j);
					}
					
					if(f[i + 1][y][c - j] == -1){
						dfs(i + 1, y, c - j);
					}
					
					f[x][y][c] = min(f[x][y][c], f[x][i][j] + f[i + 1][y][c - j]);
				}
			}
		}
	}
	
	return 0;
}

int main(){
	
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	
	int i, j;
	long long tmp;
	
	scanf("%lld", &n);
	scanf("%lld", &k);
	
	for(i=1;i<=n;i++){
		scanf("%lld", &l[i]);
		sum += l[i];
		lq[i] = sum;
		l[i + n] = l[i];
	}
	
	if(n <= 500){
		memset(f, -1, sizeof(f));
	
		dfs(1, n, k);
	
		ans = f[1][n][k];
	
		for(i=2;i<=n;i++){
			dfs(i, i - 1, k);
			ans = min(ans, f[i][i - 1][k]);
		}
	
		printf("%lld", ans);
	}else{
		ans = 10000000007;
		for(i=1;i<=n;i++){
			for(j=1;j<=n;j++){
				if(j >= i){
					tmp = lq[j] - lq[i - 1];
				}else{
					tmp = lq[j] + lq[n] - lq[i - 1];
				}
				ans = min(ans, clac(tmp) + clac(sum - tmp));
			}
		}
		printf("%lld", ans);
	}
	
	fclose(stdin);
	fclose(stdout);
	
	return 0;
}
