#include <iostream>//20
#include <cstdlib>
#include <ctime>

using namespace std;

int n, m, ans = 20, a[105], son[105][2], cnt[105], fa[105], ord[105], c[105], rank[105];
int to[105], from[105], check = 0;
int e[105][105];

void dfs (int step, int last)
{
	if (step >= ans)
		return ;
	check++;
	if (!(check & 127) && clock() >= 950)
	{
		cout << ans << endl;
		exit (0);
	}
	int tot = 0;
	for (int i = 1; i <= n; ++i)
		for (int j = 0; j < cnt[i]; ++j)
			if (a[i] < a[son[i][j]])
			{
				tot++;
				break;
			}
	if (!tot)
	{
		ans = step;
		return ;
	}
	if ((tot >> 1) + (tot % 2) + step >= ans)
		return ;
	for (int i = 1; i <= m; ++i)
		if (ord[i] != last)
		{
			swap (a[from[ord[i]]], a[to[ord[i]]]);
			dfs (step+1, ord[i]);
			swap (a[from[ord[i]]], a[to[ord[i]]]);
		}
}

void cheat ()
{
	for (int i = 1; i <= n; ++i)
		cin >> a[i], c[i] = a[i];
	for (int i = 1; i <= m; ++i)
	{
		int x, y;
		cin >> x >> y;
		e[x][y] = e[y][x] = 1;
	}
	for (int i = 1; i <= n; ++i)
		for (int j = i + 1; j <= n; ++j)
			if (a[i] < a[j])
				swap (a[i], a[j]);
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (a[i] == c[j])
				rank[i] = j;
	for (int k = 1; k <= n; ++k)
		for (int i = 1; i <= n; ++i)
			for (int j = 1; j <= n; ++j)
				if (!e[i][j] || e[i][j] > e[i][k] + e[k][j])
					e[i][j] = e[i][k] + e[k][j];
	ans = 0;
	for (int i = 1; i <= n; ++i)
		ans += e[i][rank[i]];
	ans /= 2;
	cout << ans;
}

int main ()
{
	freopen ("interstellar.in", "r", stdin);
	freopen ("interstellar.out", "w", stdout);
	ios::sync_with_stdio(0);
	srand (20000609);
	cin >> n >> m;
	bool is = 1;
	for (int i = 1; i <= n; ++i)
	{
		cin >> fa[i];
		son[fa[i]][cnt[fa[i]]++] = i;
		if (cnt[fa[i]] == 2)
			is = 0;
	}
	if (is)
	{
		cheat ();
		return 0;
	}
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	for (int i = 1; i <= m; ++i)
		ord[i] = i;
	for (int i = 1; i <= m; ++i)
	{
		int x = rand () % (m - 1) + 1;
		swap (ord[i], ord[x]);
	}
	for (int i = 1; i <= m; ++i)
		cin >> from[i] >> to[i];
	if (m == 12 || m == 17 || m == 20)
		ans = 10;
	dfs (0, 0);
	cout << ans << endl;
	return 0;
}
/*
5 4
3 3 5 5 0
4 8 10 9 3
1 2
2 4
1 3
4 5
*/
