#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

int n, m, root;
int r[20], f[20], x[150], y[150];
int g[20][20];
int dep = 0;
int t[150];
bool flag = false;

void Input ()
{
	memset (g, 1, sizeof (g));
	cin >> n >> m;
	for (int i = 1; i <= n; i ++)
	{
		cin >> r[i];
		if (r[i] == 0)
			root = i;
		g[i][i] = g[i][0] = g[0][i] = 0;
	}
	f[0] = 105;
	for (int i = 1; i <= n; i ++)
		cin >> f[i];
	for (int i = 1; i <= m; i ++)
	{
		cin >> x[i] >> y[i];
		g[x[i]][y[i]] = g[y[i]][x[i]] = 1;
	}
	for (int i = 3; i <= m; i ++)
	{
		int j = rand()%(i-1) + 1;
		swap (x[i], x[j]);
		swap (y[i], y[j]);
	}
	for (int k = 1; k <= n; k ++)
		for (int i = 1; i <= n; i ++)
			for (int j = 1; j <= n; j ++)
				g[i][j] = min (g[i][j], g[i][k]+g[k][j]);
}

void Init ()
{
	int cnt = 0, tmp, ap[20] = {0}, ord[20] = {0};
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j ++)
			if (f[i] < f[j])
				cnt ++;
		ord[cnt+1] = f[i];
		cnt  = 0;
	}
	for (int i = 1; i <= n; i ++)
		ap[r[i]] ++;
	for (int i = 1; i <= n; i ++)
		if (!ap[i])
			cnt ++, tmp = i;
	if (cnt != 1)
	{
		t[ord[1]] = root;
		return;
	}
	flag = true;
	for (int i = n; i > 0 && tmp > 0; i --, tmp = r[tmp])
		t[ord[i]] = tmp;
}

int get_Exp ()
{
	if (!flag)
	{
		for (int i = 1; i <= n; i ++)
			if (t[f[i]] > 0)
				return g[i][root];
	}
	int ret = 0;
	for (int i = 1; i <= n; i ++)
		ret += g[i][t[f[i]]];
	return (ret+1)/2;
}

bool Check ()
{
	for (int i = 1; i <= n; i ++)
		if (f[i] >= f[r[i]])
			return false;
	return true;
}

bool DFS (int h, int last)
{
	if (Check())
		return true;
	if (h == dep || h+get_Exp() > dep)
		return false;
	for (int i = 1; i <= m; i ++)
		if (i != last)
		{
			swap (f[x[i]], f[y[i]]);
			if (DFS (h+1, i))
				return true;
			swap (f[x[i]], f[y[i]]);
		}
	return false;
}

int main ()
{
	srand(18931226);
	ios::sync_with_stdio (false);
	freopen ("interstellar.in", "r", stdin);
	freopen ("interstellar.out", "w", stdout);
	Input();
	Init();
	while (!DFS(0, 0) && (m < 10 || dep < 10))
		dep ++;
	cout << dep << endl;
	return 0;
}
