#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>

using namespace std;

int n, k;
int l[600005];
int sum[600005], avg = 0;
int t[25];
long long ans = 1e18;

int read ()
{
	int ret = 0;
	char s = getchar();
	while (s > '9' || s < '0')
		s = getchar();
	while (s >= '0' && s <= '9')
		ret = ret*10 + (s-'0'), s = getchar();
	return ret;
}

long long sqr (int x)
{
	return 1LL*x*x;
}

void DFS (int st, int now, int num)
{
	if (num > k)
	{
		long long ret = 0;
		for (int i = 1; i < k; i ++)
			ret += sqr(sum[t[i+1]]-sum[t[i]]-avg);
		ret += sqr(sum[t[1]+n]-sum[t[k]]-avg);
		ans = min (ans, ret);
		return;
	}
	int l = now, r = st+n-1;
	while (l < r)
	{
		int mid = (l+r) >> 1;
		if (sum[mid]-sum[l-1] < avg)
			l = mid+1;
		else
			r = mid;
	}
	t[num] = l;
	DFS (st, l, num+1);
	t[num] = l+1;
	DFS (st, l+1, num+1);
	t[num] = 0;
}

int main ()
{
	freopen ("spaceship.in", "r", stdin);
	freopen ("spaceship.out", "w", stdout);
	n = read();
	k = read();
	for (int i = 1; i <= n; i ++)
	{
		l[i] = read();
		avg += l[i];
		l[i] *= k;
		l[i+n] = l[i];
	}
	for (int i = 1; i <= n+n; i ++)
		sum[i] = sum[i-1] + l[i];
	if (n <= 1000 && k == 2)
	{
		for (int i = 1; i <= n-1; i ++)
			for (int j = i+1; j <= n; j ++)
				ans = min (ans, sqr(sum[j]-sum[i]-avg) + sqr(sum[i+n]-sum[j]-avg));
	}
	else if (n <= 100 && k == 3)
	{
		for (int i = 1; i <= n-2; i ++)
			for (int j = i+1; j <= n-1; j ++)
				for (int p = j+1; p <= n; p ++)
					ans = min (ans, sqr(sum[j]-sum[i]-avg) + sqr(sum[p]-sum[j]-avg) + sqr(sum[i+n]-sum[p]-avg));
	}
	else if (n <= 50 && k == 6)
	{
		for (int i1 = 1; i1 <= n-5; i1 ++)
		for (int i2 = i1+1; i2 <= n-4; i2 ++)
		for (int i3 = i2+1; i3 <= n-3; i3 ++)
		for (int i4 = i3+1; i4 <= n-2; i4 ++)
		for (int i5 = i4+1; i5 <= n-1; i5 ++)
		for (int i6 = i5+1; i6 <= n; i6 ++)
			ans = min (ans, sqr(sum[i2]-sum[i1]-avg) + sqr(sum[i3]-sum[i2]-avg) + sqr(sum[i4]-sum[i3]-avg)
						+ sqr(sum[i5]-sum[i4]-avg) + sqr(sum[i6]-sum[i5]-avg) + sqr(sum[i1+n]-sum[i6]-avg));
	}
	else
	{
		for (int i = 1; i <= n; i ++)
		{
			t[1] = i;
			DFS (i, i, 2);
			t[1] = 0;
		}
	}
	cout << ans << endl;
	return 0;
}
