#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

typedef long long LL;

#define ms(a, w) memset(a, w, sizeof(a))
#define m2(x) ((x) * (x))

const int MAXN = 300010;

int a[MAXN];
LL s[MAXN * 2];
int n, K;
LL f[512][32];

LL calc (int i, LL v) {
	return *(upper_bound(s + i, s + 2 * n, v / 2 + s[i]) - 1);
}

int main () {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	ios::sync_with_stdio(false);
	cin >> n >> K;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		s[i] = s[i + n] = a[i];
	}
	for (int i = 1; i <= 2 * n; i++)
		s[i] += s[i - 1];
	if (K == 2) {
		LL ans = 1e18;
		for (int i = 0, j = 1; i < n; i++) {
			LL k = calc(i, s[n]);
			ans = min(ans, m2(2 * (k - s[i]) - s[n]) * 2);
		}
		cout << ans << endl;
	}
	else if (K == 3) {
		LL ans = 1e18;
		for (int i = 0, j = 1; i < n; i++) {
			if (j == i)
				j++;
			while (calc(j + 1, s[n] - s[j] + s[i]) - s[j] > s[j] - s[i])
				j++;
			LL k = calc(j, s[n] - s[j] + s[i]);
			ans = min(ans, m2(3 * (s[j] - s[i]) - s[n]) + m2(3 * (k - s[j]) - s[n]) + m2(3 * (s[n] - k + s[i]) - s[n]));
		}
		cout << ans << endl;
	}
	else {
		LL ans = 1e18;
		for (int o = 0; o < n; o++) {
			ms(f, 63);
			f[0][0] = 0;
			for (int i = 1; i <= n; i++) {
				for (int j = 1; j <= K; j++)
					for (int k = 0; k < i; k++)
						f[i][j] = min(f[i][j], f[k][j - 1] + m2(K * (s[i + o] - s[k + o]) - s[n]));
			}
			ans = min(ans, f[n][K]);
		}
		cout << ans << endl;
	}
	
	return 0;
}
