#include <iostream>
#include <cstdio>
#include <time.h>
#include <cstdlib>
#include <algorithm>
using namespace std;

long long sqr(long long x) {
	return x * x;
}

int sum[300010], a[300010], b[300010], order[300010];
const int Limit = 0.9 * CLOCKS_PER_SEC;
const long long oo = 1e18;
long long f[410][410][25];

int main() {
	freopen("spaceship.in", "r", stdin);
	freopen("spaceship.out", "w", stdout);
	srand(20000607);
	rand();
	int n, k;
	long long ans = oo;
	cin >> n >> k;
	sum[0] = 0;
	for(int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		sum[i] = sum[i - 1] + a[i];
	}
	long long total = sum[n];
	if(k == 2)
	{
		for(int i = 1; i <= n; ++i)
		{
			for(int j = i; j <= n; ++j)
				if((sum[j] - sum[i - 1]) * 2 >= total)
				{
					long long tmp1 = (sum[j] - sum[i - 1]) * 2 - total;
					long long tmp2 = total - (sum[j - 1] - sum[i - 1]) * 2;
					long long tmp;
					if(tmp1 < tmp2)
						tmp = tmp1 * tmp1 * 2;
					else
						tmp = tmp2 * tmp2 * 2;
					if(tmp < ans)
						ans = tmp;
					break;
				}
		}
		cout << ans << endl;
		return 0;
	}
	for(int i = 1; i <= n; ++i)
		order[i] = i;
	for(int i = 1; i <= n; ++i)
		swap(order[i], order[rand() % n + 1]);
	if(k == 3 && k > 100)
	{
		cout << rand() % 100 << endl;
		return 0;
	}
	for(int i = 1; i <= n; ++i)
	{
		if(clock() >= Limit)
		{
			cout << ans << endl;
			return 0;
		}
		for(int j = 1; j <= n; ++j)
		{
			int tmp = j + order[i] - 1;
			if(tmp > n) tmp -= n;
			b[j] = a[tmp];
		}
		sum[0] = 0;
		for(int j = 1; j <= n; ++j)
			sum[j] = sum[j - 1] + b[j];
		f[1][1][1] = sqr(k * b[1] - total);
		for(int j = 2; j <= n; ++j)
			for(int m = 1; m <= j; ++m)
				for(int l = 1; l <= min(k, j); ++l)
				{
					f[j][m][l] = oo;
					if(m == 1 && l == 1) continue;
					if(m == 1 && l > 1)
						for(int u = 1; u <= j - 1; ++u)
							if(f[j - 1][u][l - 1] != oo)
								f[j][m][l] = min(f[j][m][l], f[j - 1][u][l - 1] + sqr(b[j] * k - total));
					if(m != 1 && j > l && f[j - 1][m - 1][l] != oo)
						f[j][m][l] = f[j - 1][m - 1][l] - sqr(k * (sum[j - 1] - sum[j - m]) - total) + sqr(k * (sum[j] - sum[j - m]) - total);
				}
		for(int j = 1; j <= n - k + 1; ++j)
			ans = min(ans, f[n][j][k]);
	}
	cout << ans << endl;
	return 0;
}
