#include <fstream>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
using namespace std;
ifstream cin("spaceship.in");
ofstream cout("spaceship.out");
const int maxn = 300001, maxk = 21;
int a[maxn], presum[maxn];
int n, k;
double ans, avg, csum;
int delim[maxk];

int dfs(int p)
{
	if(p == k)
	{
		double sub = (avg - (presum[delim[0]-1] + presum[n] - presum[delim[k-1]-1]));
		ans = min(ans, csum + sub*sub);
	}
	else
	{
		int i, starter = (p == 0 ? 1 : delim[p-1]);
		for(i = starter; i <= n+1; i++)
		{
			delim[p] = i;
			if(p > 0)
			{
				double sub = (avg - (presum[delim[p]-1] - presum[delim[p-1]-1]));
				if(csum + sub*sub > ans)
					continue;
				csum += sub*sub;
				//cout << p << ' ' << csum << endl;
				dfs(p+1);
				csum -= sub*sub;
				//cout << p << ' ' << csum << endl;
			}
			else
			{
				dfs(1);
			}
		}
	}
}

int main()
{
	cin >> n >> k;
	int i, j;
	avg = 0;
	ans = 1e16;
	for(i = 1; i <= n; i++)
	{
		cin >> a[i];
		presum[i] = presum[i-1] + a[i];
	}
	avg = presum[n] * 1.0 / k;
	//cout << "avg=" << avg << endl;
	csum = 0;
	dfs(0);
	cout << ans*k*k << endl;
	return 0;
}

