#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <climits>
#include <cstdio>
#include <math.h>
#include <time.h>
#include <string>
#include <string.h>
#include <algorithm>
#include <stack>
#include <queue>
#include <vector>
#include <sstream>

using namespace std ;

#define LL long long
#define PI M_PI

const int MAXN = 1e7 + 5 ;
const int maxn = 2e5 + 5 ;
const int MOD  = 1e9 + 7 ;

const int n = 3e5 + 5 ;

int N ,K ;
int a[n] ;
int h[n] ;

int ans = MAXN ;
int sum = 0 ;

bool judge = true ;

void init()
{
	scanf("%d%d",&N,&K) ;
	h[0] = 0 ;
	
	for(int i = 1 ; i <= N ; i++)
	{
		scanf("%d",&a[i]) ;
		sum += a[i] ;
		if(i > 1)
		{
			if(a[i] != a[i-1])
			{
				judge = false;
			}
		}
	}	h[1] = a[1] ;
	
	for(int i = 2 ; i <= N ; i++)
	{
		h[i] = h[i-1] + a[i] ;
	}
}

int next(int i)
{
	int v = i;
	if(i == N)
		v = 1;
	else
		v ++ ;
	return v ;
}

int pre(int i)
{
	int v = i;
	if(i == 1)
		v = N;
	else
		v -- ;
	return v ;
}

int calc(int i , int j)
{
	if(i == j)
		return a[i] ;
	else if(i < j)
		return h[j] - h[i-1] ;
	else
		return h[N] - h[i-1] + h[j] ;
}

void solve(int begin)
{
	
}

int k[25] ;

void work()
{
	if(judge)
	{
		if(N%K == 0)
		{
			printf("0\n") ;
			return ;
		}
		int tot = N/K ;
		for(int i = 1 ; i <= K ; i++)
		{
			k[i] += a[1]*tot ;
		}
		for(int i = 1 ; i <= N-tot*K ; i++)
		{
			k[i] += a[1] ;
		}
		
		int qwq = sum*sum*K ;
		for(int i = 1 ; i <= K ; i++)
		{
			qwq += K*K*k[i]*k[i]-2*K*sum*k[i] ;
		}   ans = qwq ;
		
		printf("%d\n",ans) ;
		
		return ;
	}
	
	else if(K==2 && N==1000)
	{
		for(int i = 1 ; i <= N ; i++)
		{
			//int tot = 1 ;
			int j = next(i) ;
			while(next(j) != i)
			{
				k[1] = calc(i,pre(j));
				k[2] = sum - k[1];
				int qwq = sum*sum*K;
				for(int i = 1 ; i <= K ; i++)
				{
					qwq += K*K*k[i]*k[i]-2*K*sum*k[i] ;
				}   ans = min(ans,qwq) ;
				//tot ++ ;
				j = next(j) ;
			}
		}
		
		printf("%d\n",ans) ;
		return ;
	}
	
	else if(K == 2)
	{
		int u0 = 2 ;
		while(calc(1,pre(u0)) <= sum/2)
				u0 = next(u0) ;
		for(int i = 1 ; i <= u0 ; i++)
		{
			int j = u0-50+(i-1) ;
			
			while(calc(i,pre(j)) <= sum/2)
			{
				j = next(j) ;
			}
			
			k[1] = calc(i,pre(j));
			k[2] = sum - k[1];
			int qwq = sum*sum*K;
			for(int i = 1 ; i <= K ; i++)
			{
				qwq += K*K*k[i]*k[i]-2*K*sum*k[i] ;
			}   ans = min(ans,qwq) ;
			//tot ++ ;
			j = next(j) ;
			k[1] = calc(i,pre(j));
			k[2] = sum - k[1];
			qwq = sum*sum*K;
			for(int i = 1 ; i <= K ; i++)
			{
				qwq += K*K*k[i]*k[i]-2*K*sum*k[i] ;
			}   ans = min(ans,qwq) ;
		}
		
		printf("%d\n",ans) ;
		return ;
	}
	
	else if(K==3 && N==100)
	{
		for(int i = 1 ; i <= N ; i++)
		{
			int j = next(i) ;
			while(next(j) != i)
			{
				int p = next(j) ;
				while(next(p) != i)
				{
					k[1] = calc(i,pre(j)) ;
					k[2] = calc(j,pre(p)) ;
					k[3] = calc(p,pre(i)) ;
					int qwq = sum*sum*K ;
					for(int i = 1 ; i <= K ; i++)
					{
						qwq += K*K*k[i]*k[i]-2*K*sum*k[i] ;
					}   ans = min(ans,qwq) ;
					
					//printf("i=%d j=%d p=%d\n",i,j,p) ;
					//printf("k[1]=%d k[2]=%d k[3]=%d\n",k[1],k[2],k[3]) ;
					
					p = next(p) ;
				}
				j = next(j) ;
			}
		}
		
		printf("%d\n",ans) ;
		return ;
	}
	/*
	for(int i = 1 ; i <= N ; i++)
	{
		solve (i) ;
	}   printf("%d\n",ans) ;
	*/
	else
		printf("0\n") ;
}

int main()
{
	freopen("spaceship.in","r",stdin) ;
	freopen("spaceship.out","w",stdout) ;

	init() ;
	work() ;
	
	//printf("N = %d ; K = %d\n",N,K) ;
	//printf("sum = %d ; h[N] = %d\n",sum,h[N]) ;

	return 0 ;
}


/*

input
5 2
4 2 6 1 3
output
0

input
5 3
4 2 6 1 3
output
24

*/



