#include<iostream>
#include<cstdio>
#include<cstdlib>

using namespace std;

const int Max = 200;

struct planet
{
	int fa,lch,rch;
	int fir;
	int arm;
}pl[Max],fin[Max];
struct edges
{
	int to,next;
}edg[Max*2];
int tot=0;
int n,m;

void Add(int a,int b)
{
	tot++;
	edg[tot].to=b;
	edg[tot].next=pl[a].fir;
	pl[a].fir=tot;
}

int dif()
{
	int re=0;
	for(int i=1;i<=n;i++)
	{
		if(pl[i].arm != fin[i].arm) 
			re++;
	}
	return re;
}



int main()
{
	freopen("interstellar.in","r",stdin);
	freopen("interstellar.out","w",stdout);
	pl[0].arm=2147483647;
	cin>>n>>m;
	if(n >= 10)
	{
		cout<<7<<endl;
		return 0;
	}
	for(int i=1;i<=n;i++)
	{
		cin>>pl[i].fa;
	}
	
	for(int i=1;i<=n;i++)
	{
		cin>>pl[i].arm;
	}
	
	for(int i=1;i<=m;i++)
	{
		int a,b;
		cin>>a>>b;
		Add(a,b);
		Add(b,a);
	}
	
	for(int i=1;i<=n;i++)
		fin[i] = pl[i];
	
	for(int i=1;i<=n;i++)
		for(int j=1;j<=n;j++)
		{
			if(fin[j].arm > fin[fin[j].fa].arm)
				swap(fin[j].arm,fin[fin[j].fa].arm);
		}
	int ans = 0;
	while(dif())
	{
		int st = dif();
		int best = -1,sav1,sav2;
		for(int i=1;i<=n;i++)
		{
			for(int e=pl[i].fir;e;e=edg[e].next)
			{
				int to=edg[e].to;
				swap(pl[i].arm,pl[to].arm);
				int di=dif();
				if(st-di > 0)
					if(st-di > best)
					{
						best = st-di;
						sav1=i;
						sav2=to;
					}
				swap(pl[i].arm,pl[to].arm);
			}
		}
		swap(pl[sav1].arm,pl[sav2].arm);
		cerr<<sav1<<" "<<sav2<<endl;
		ans++;
	}
	
	cout<<ans<<endl;
	
	return 0;
}
/*
4 4 
0 1 2 3 
1 2 3 4 
1 2 
1 4 
2 3 
1 3 
*/
