#include<stdio.h>
#include<iostream>
#include<cmath>

using namespace std;

int n,m,s,t;
int v[201010];
int a[1010][1010];
int size[1010],cnt;
int mx[1010],mn[1010],del[1010];

void fix_m(int i)
{
	mx[i]=0;mn[i]=1e9;
	for(int j=0;j<size[i];j++)
	{
		mx[i]=max(mx[i],a[i][j]);
		mn[i]=min(mn[i],a[i][j]);
	}
}

void fix_del(int i)
{
	del[i]=1e9;
	for(int j=1;j<size[i];j++)
		del[i]=min(del[i],abs(a[i][j]-a[i][j-1]));
}

void rebuild()
{
	s=sqrt(n);
	cnt=n/s+1;
	for(int i=0;i<cnt;i++)
	{
		size[i]=min(s,n-i*s);
		for(int j=0;j<size[i];j++)
			a[i][j]=v[i*s+j];
		fix_m(i);
		fix_del(i);
	}
}

void get_val()
{
	n=0;
	for(int i=0;i<cnt;i++)
		for(int j=0;j<size[i];j++)
			v[n++]=a[i][j];
}

void merge(int x,int e)
{
	int now=0;
	for(int i=0;i<cnt;now+=size[i++])
		if(now<=x&&now+size[i]>x)
		{
			if(now+size[i]==x+1)
			{
				size[i]--;
				fix_m(i);
				fix_del(i);
				for(i++;!size[i];i++);
				a[i][0]=e;
				fix_m(i);
				fix_del(i);
			}
			else
			{
				for(int j=x-now+1;j<size[i]-1;j++)
					a[i][j]=a[i][j+1];
				a[i][x-now]=e;
				size[i]--;
				fix_m(i);
				fix_del(i);
			}
			return;
		}
}

void insert(int x,int e)
{
	int now=0;
	for(int i=0;i<cnt;now+=size[i++])
		if(now<=x&&now+size[i]>x)
		{
			for(int j=size[i];j>x-now+1;j--)
				a[i][j]=a[i][j-1];
			a[i][x-now+1]=e;
			size[i]++;
			mx[i]=max(mx[i],e);
			mn[i]=min(mn[i],e);
			fix_del(i);
			return;
		}
}

int calc_max(int x,int y)
{
	int now=0;
	int now_max=0,now_min=1e9;
	for(int i=0;i<cnt&&now<y;now+=size[i++])
	{
		if(now+size[i]<x)	continue;
		else if(now<x)
			for(int j=x-now;j<size[i];j++)
			{
				now_max=max(now_max,a[i][j]);
				now_min=min(now_min,a[i][j]);
			}
		else if(now+size[i]<=y)
		{
			now_max=max(now_max,mx[i]);
			now_min=min(now_min,mn[i]);
		}
		else
			for(int j=0;j<y-now;j++)
			{
				now_max=max(now_max,a[i][j]);
				now_min=min(now_min,a[i][j]);
			}
	}
	return now_max-now_min;
}

int calc_min(int x,int y)
{
	int now=0,last=-1e9;
	int min_del=1e9;
	for(int i=0;i<cnt&&now<y;now+=size[i++])
	{
		if(!size[i])	continue;
		if(now+size[i]<x)	continue;
		else if(now<x)
		{
			for(int j=x-now+1;j<size[i];j++)
				min_del=min(min_del,abs(a[i][j]-a[i][j-1]));
			last=a[i][size[i]-1];
		}
		else if(now+size[i]<=y)
		{
			min_del=min(min_del,abs(a[i][0]-last));
			min_del=min(min_del,del[i]);
			last=a[i][size[i]-1];
		}
		else
		{
			min_del=min(min_del,abs(a[i][0]-last));
			for(int j=1;j<y-now;j++)
				min_del=min(min_del,abs(a[i][j]-a[i][j-1]));
		}
	}
	return min_del;
}

int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=0;i<n;i++)
		scanf("%d",&v[i]);
	t=sqrt(m);
	for(int i=0;i<m;i+=t)
	{
		rebuild();
		for(int j=i;j<min(i+t,m);j++)
		{
			char ord[10];
			int x,y;
			scanf("%s%d%d",&ord,&x,&y);
			x--;
			if(ord[1]=='e')	merge(x,y);
			if(ord[1]=='n')	insert(x,y);
			if(ord[1]=='a')	cout<<calc_max(x,y)<<endl;
			if(ord[1]=='i')	cout<<calc_min(x,y)<<endl;
		}
		get_val();
	}
	return 0;
}
