#include<cstdio>
#include<cctype>
#include<algorithm>
#include<cstring>
#define maxn 100005
using namespace std;
const int INF=1e9;
inline int read()
{
	int x=0,f=1;char c=getchar();
	for(;!isdigit(c);c=getchar()) if(c=='-') f=-1;
	for(;isdigit(c);c=getchar()) x=x*10+c-'0';
	return x*f;
}
int E[maxn],maxv[maxn<<2],minv[maxn<<2],mins[maxn<<2];
int left[maxn<<2],right[maxn<<2];
int abs(int x)
{
	return x<0 ? (-x) : x;	
}
void build(int o,int L,int R)
{
	if(L==R)
	{
		minv[o]=E[L];
		maxv[o]=E[L];
		left[o]=E[L];
		right[o]=E[L];
		return;
	}
	int lc=o<<1,rc=lc|1,mid=L+R>>1;
	build(lc,L,mid);
	build(rc,mid+1,R);
	minv[o]=min(minv[lc],minv[rc]);
	maxv[o]=max(maxv[lc],maxv[rc]);
	right[o]=right[rc];
	left[o]=left[lc];
	if(L+1==R)
	{
		mins[o]=maxv[o]-minv[o];
		return;
	}
	mins[o]=INF;
	if(L<mid) mins[o]=min(mins[o],mins[lc]);
	if(R>mid+1) mins[o]=min(mins[o],mins[rc]);
	mins[o]=min(mins[o],abs(left[rc]-right[lc]));
}
int query_max(int o,int L,int R,int ql,int qr)
{
	if(ql>R || qr<L) return -INF;
	if(ql<=L && R<=qr) return maxv[o];
	int lc=o<<1,rc=lc|1,mid=L+R>>1;
	return max(query_max(lc,L,mid,ql,qr),query_max(rc,mid+1,R,ql,qr));
}
int query_min(int o,int L,int R,int ql,int qr)
{
	if(ql>R || qr<L) return INF;
	if(ql<=L && R<=qr) return minv[o];
	int lc=o<<1,rc=lc|1,mid=L+R>>1;
	return min(query_min(lc,L,mid,ql,qr),query_min(rc,mid+1,R,ql,qr));
}
int query_mins(int o,int L,int R,int ql,int qr)
{
	if(ql>R || qr<L || L==R) return INF;
	if(ql<=L && R<=qr) return mins[o];
	int lc=o<<1,rc=lc|1,mid=L+R>>1;
	int ans=min(query_mins(lc,L,mid,ql,qr),query_mins(rc,mid+1,R,ql,qr));
	if(ql<=mid && qr>mid) ans=min(ans,abs(left[rc]-right[lc]));
	return ans;
}
int main()
{
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	int n=read(),m=read();
	for(int i=1;i<=n;i++) E[i]=read();
	build(1,1,n);
	char s[10];
	while(m--)
	{
		scanf("%s",&s);
		int L=read(),R=read();
		if(s[1]=='a') printf("%d\n",query_max(1,1,n,L,R)-query_min(1,1,n,L,R));
		else if(s[1]=='i') printf("%d\n",query_mins(1,1,n,L,R));
	}
 	return 0;
}
