#include <cstdio>
#include <cstdlib>
using namespace std;

const int _N=18,_P=123;

int pooltop;
struct Edge {
	int to;
	Edge *next;
} pool[_N*2],*head[_N];
int holiness[_N];

int points,root=-1;

int possi[_N][2],possibs;

inline void quickswap(int &a,int &b) { // why no -O2 ?
	int t=a;
	a=b;
	b=t;
}

inline void addedge(int from) {
	int par;
	scanf("%d",&par);
	if(par==0) {
		root=from;
		return;
	}
	Edge *self=&pool[pooltop++];
	self->to=from; self->next=head[par]; head[par]=self;
}

bool isvalid(int from) {
	//printf("judge %d\n",from);
	for(Edge *self=head[from];self;self=self->next)
		if(holiness[self->to]>holiness[from] || !isvalid(self->to))
				return false;
	//printf("judge %d OK\n",from);
	return true;
}

int maxdep; // update in main()
inline void holysearch(int dep) {
	if(dep==maxdep)
		if(isvalid(root)) {
			printf("%d\n",dep);
			exit(0);
		}
		else
			return;
	else
		for(int i=1;i<=possibs;i++) {
			quickswap(holiness[possi[i][0]],holiness[possi[i][1]]);
			holysearch(dep+1);
			quickswap(holiness[possi[i][0]],holiness[possi[i][1]]);
		}
}

int main() {
	freopen("interstellar.in","r",stdin);
	freopen("interstellar.out","w",stdout);
	
	scanf("%d%d",&points,&possibs);
	for(int i=1;i<=points;i++)
		addedge(i);
	for(int i=1;i<=points;i++)
		scanf("%d",holiness+i);
		
	for(int i=1;i<=possibs;i++) {
		scanf("%d%d",&(possi[i][0]),&(possi[i][1]));
	}
	
	while(true) {
		//printf("search dep %d\n",maxdep);
		holysearch(0);
		maxdep++;
	}
}
