#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<map>
#include<vector>
#include<queue>
#include<stack>
#include<sstream>
using namespace std;
const double limit=1.91*CLOCKS_PER_SEC;
const int oo=1e9;
struct Edge
{
	int to,next;
}edges[505];
int te=1;
int points[105];
void adde(const int &a,const int &b)
{
	te++;
	edges[te].to=b;
	edges[te].next=points[a];
	points[a]=te;
}
int par[105],son[105];
int mn=oo;
int n,m;
double st;
int cnt=0;
int asd[20];
map<string,int>vis;
map<string,bool>mark;
bool correct(int *now)
{
	for(int i=1;i<=n;i++)
		if(now[par[i]]<=now[i]&&par[i])
			return 0;
	return 1;
}
bool visit(int *now,const int &l)
{
	string s="";
	for(int i=1;i<=n;i++)
	{
		s+=(char)(now[i]/10)+'0';
		s+=(char)(now[i]%10)+'0';
	}
	if(mark[s]&&vis[s]<=l)
		return 1;
	vis[s]=l;
	mark[s]=1;
	return 0;
}
void dfs(int *now,const int &s)
{
	if(!(++cnt&255)&&1.0*clock()/CLOCKS_PER_SEC-st>limit)
	{
		cout<<mn<<endl;
		exit(0);
	}
	if(s>=mn||visit(now,s))
		return;
	if(correct(now))
	{
		mn=s;
		return;
	}
	int mod=rand()%2;
	if(!mod)
		for(int i=1;i<=n;i++)
			for(int e=points[i];e;e=edges[e].next)
			{
				swap(now[i],now[edges[e].to]);
				dfs(now,s+1);
				swap(now[i],now[edges[e].to]);
			}
	else
		for(int i=n;i>=1;i--)
			for(int e=points[i];e;e=edges[e].next)
			{
				swap(now[i],now[edges[e].to]);
				dfs(now,s+1);
				swap(now[i],now[edges[e].to]);
			}
}
int main()
{
	freopen("interstellar.in","r",stdin);
	freopen("interstellar.out","w",stdout);
	std::ios::sync_with_stdio(false);
	st=1.0*clock()/CLOCKS_PER_SEC;
	srand(18931226);    //mod ëϯ 
	cin>>n>>m;
	for(int i=1;i<=n;i++)
	{
		cin>>par[i];
		son[par[i]]=i;
	}
	for(int i=1;i<=n;i++)
	{
		cin>>asd[i];
		asd[i]--;
	}
	for(int i=1;i<=m;i++)
	{
		int x,y;
		cin>>x>>y;
		adde(x,y);
		adde(y,x);
	}
	dfs(asd,0);
	cout<<mn<<endl;
	
	return 0;
}
