#include<iostream>
#include<cstdio>
#include<cmath>
#include<cstring>
#include<cstdlib>
#include<algorithm>
using namespace std;

typedef struct Node
{
	int l,r;
	int le,re;
	int maxe,mine;
	int maxpr,minpr;
	Node *lt,*rt;
	//int lazy;
} *pnode;
pnode root;
int n,m;
int e[101000];

pnode buildtree(int l,int r)
{
	//cout<<l<<" "<<r<<endl;
	pnode p,a,b;
	if(r-l<=1)
	{
		p->l=l;
		p->r=r;
		p->maxe=p->mine=p->le=p->re=e[l];
		p->maxpr=0;
		p->minpr=0;
		p->rt=p->lt=0;
		return p;
	}
	int mid=(l+r)/2;
	a=buildtree(l,mid);
	p->lt=a;
	//cout<<p->lt->maxe<<endl;
	b=buildtree(mid,r);
	p->rt=b;
	//cout<<p->rt->maxe<<endl;
	//cout<<p->lt->maxe<<" "<<p->rt->maxe<<endl;
	//int l0=p->lt->maxe,r0=p->rt->maxe;
	//cout<<"A"<<endl;
	p->maxe=max(a->maxe,b->maxe);
	p->mine=min(a->mine,b->mine);
	p->maxpr=p->maxe-p->mine;
	//cout<<a->maxe<<endl;
	//cout<<p->mine<<endl;
	//cout<<"A"<<endl;
	p->minpr=min(a->minpr,b->minpr);
	p->minpr=min(p->minpr,abs(a->re-b->le));
	//cout<<"A"<<endl;
	p->le=a->le;
	p->re=b->re;
	//cout<<"A"<<endl;
	return p;
}

pnode search(pnode ro,int l,int r)
{
	if(l-r<=1)
	{
		return ro;
	}
	if(l<=ro->l&&r>=ro->r)
	{
		return ro;
	}
	int mid=(ro->l+ro->r)/2;
	pnode a,b;
	if(l<mid)
	{
		pnode a=search(ro->lt,l,mid);
	}
	else
	{
		return search(ro->rt,mid,r);
	}
	if(r>=mid)
	{
		pnode b=search(ro->rt,mid,r);
	}
	else
	{
		return search(ro->lt,l,mid);
	}
	pnode p;
	p->le=a->le;
	p->re=b->re;
	p->maxe=max(a->maxe,b->mine);
	p->mine=min(a->mine,b->mine);
	p->maxpr=p->maxe-p->mine;
	p->minpr=min(a->minpr,b->minpr);
	p->minpr=min(p->minpr,abs(a->re-b->le));
	p->lt=p->rt=0;
	return p;
}

int main()
{
	//freopen("atom.in","r",stdin);
	//freopen("atom.out","w",stdout);
	cin>>n>>m;
	for(int i=1;i<=n;i++)
	{
		cin>>e[i];
	}
	root=buildtree(1,n+1);
	
	for(int i=1;i<=m;i++)
	{
		string s;
		int x,y;
		cin>>s>>x>>y;
		if(s=="max")
		{
			pnode p=search(root,1,n+1);
			cout<<p->maxpr<<endl;
		}
		if(s=="min")
		{
			pnode p=search(root,1,n+1);
			cout<<p->minpr<<endl;
		}
	}
}
