#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
using namespace std;
const int MAXN=100010,INF=1000000010;
int n,m,v[MAXN],d[MAXN];
struct spaly{
	spaly *pnt,*son[2];
	int d,max,min,size;
}pool[10*MAXN],*root[2];
int cnt;
void Update(spaly *o){
	o->size=1;
	if(o->d==-1033)o->max=-1,o->min=INF;
	else o->max=o->min=o->d;
	if(o->son[0]){
		o->max=max(o->max,o->son[0]->max);
		o->min=min(o->min,o->son[0]->min);
		o->size+=o->son[0]->size;
	}
	if(o->son[1]){
		o->max=max(o->max,o->son[1]->max);
		o->min=min(o->min,o->son[1]->min);
		o->size+=o->son[1]->size;
	}
}
spaly * buildtree(int *x,int left,int right){
	spaly *o=&pool[cnt++];
	int mid=(left+right)/2;
	o->d=x[mid];
	if(mid>left){
		o->son[0]=buildtree(x,left,mid-1);
		o->son[0]->pnt=o;
	}
	if(mid<right){
		o->son[1]=buildtree(x,mid+1,right);
		o->son[1]->pnt=o;
	}
	Update(o);
	return o;
}
void Rotate(spaly *o,int r){
	spaly *p=o->pnt,*q;
	int c=(o==p->son[1]);
	q=o->son[c^1];
	o->pnt=p->pnt;
	if(p->pnt)p->pnt->son[p==p->pnt->son[1]]=o;
	else root[r]=o;
	p->pnt=o;
	o->son[c^1]=p;
	if(q)q->pnt=p;
	p->son[c]=q;
	Update(p);
	Update(o);
}
int Query(int x,int r){
    int s=0,ls;
    spaly *o=root[r];
    while(1){
    	if(o->son[0])ls=o->son[0]->size;else ls=0;
    	if(s+ls+1==x)return o->d;
    	if(x<=s+ls)o=o->son[0];
    	else s+=ls+1,o=o->son[1];
	}
}
spaly * Find(int x,int r){
    int s=0,ls;
    spaly *o=root[r];
    while(1){
    	if(o->son[0])ls=o->son[0]->size;else ls=0;
    	if(s+ls+1==x)return o;
    	if(x<=s+ls)o=o->son[0];
    	else s+=ls+1,o=o->son[1];
	}
}
void Splay(spaly *o,int r){
	while(o!=root[r]&&o->pnt!=root[r]){
		if((o==o->pnt->son[1])==(o->pnt==o->pnt->pnt->son[1]))Rotate(o->pnt,r);
		else Rotate(o,r);
		Rotate(o,r);
	}
	if(o!=root[r])Rotate(o,r);
}
void Spque(int left,int right,int x){
	spaly *l=Find(left,x),*r=Find(right,x);
	Splay(r,x);
	while(l->pnt!=r&&l->pnt->pnt!=r){
		if((l==l->pnt->son[1])==(l->pnt==l->pnt->pnt->son[1]))Rotate(l->pnt,x);
		else Rotate(l,x);
		Rotate(l,x);
	}
	while(l!=root[x])Rotate(l,x);
}
void outp(int x){
	if(x==0){putchar('0');putchar('\n');return;}
	char c[30];
	int i=0;
	while(x){c[i++]=x%10+'0';x/=10;}
	while(i)putchar(c[--i]);
	putchar('\n');
}
int main(){
	char ch[100];
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	int x,y;
	long long ans=0;
	spaly *o,*p,*q;
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++){
		scanf("%d",&v[i+1]);
		if(i>1)d[i]=abs(v[i+1]-v[i]);
	}
	v[1]=v[n+2]=-1033;
	d[1]=d[n+1]=-1033;
	root[0]=buildtree(v,1,n+2);
	root[1]=buildtree(d,1,n+1);
	for(int i=1;i<=m;i++){
		scanf("%s%d%d",ch,&x,&y);
		if(strcmp(ch,"merge")==0){
			Spque(x,x+3,0);
			o=root[0]->son[1]->son[0];
			o->son[0]=o->son[1]=NULL;
			o->d=y;
			Update(o),Update(o->pnt),Update(root[0]);
			if(x==1){
				Spque(1,4,1);
				o=root[1]->son[1]->son[0];
				o->son[0]=o->son[1]=NULL;
				o->d=abs(Query(2,0)-Query(3,0));
				Update(o),Update(o->pnt),Update(root[1]);
			}else if(x==root[0]->size-2){
				Spque(x-1,x+2,1);
				o=root[1]->son[1]->son[0];
				o->son[0]=o->son[1]=NULL;
				o->d=abs(Query(x,0)-Query(x+1,0));
				Update(o),Update(o->pnt),Update(root[1]);
			}else{
				Spque(x-1,x+3,1);
				o=root[1]->son[1]->son[0];
				o->son[0]=o->son[1]=NULL;
				p=&pool[cnt++];
				o->d=abs(Query(x+1,0)-Query(x,0));
				p->d=abs(Query(x+2,0)-Query(x+1,0));
				o->son[1]=p,p->pnt=o;
				Update(p),Update(o),Update(o->pnt),Update(root[1]);
			}
		}
		if(strcmp(ch,"insert")==0){
			Spque(x+1,x+2,0);
			o=&pool[cnt++];
			o->d=y;
			o->pnt=root[0]->son[1];
			root[0]->son[1]->son[0]=o;
			Update(o);
			Update(root[0]->son[1]);
			Update(root[0]);
			if(x==root[0]->size-3){
				Splay(Find(x,1),1);
				o=&pool[cnt++];
				o->d=abs(Query(x+2,0)-Query(x+1,0));
				o->pnt=root[1]->son[1];
				root[1]->son[1]->son[0]=o;
				Update(o);
				Update(root[1]->son[1]);
				Update(root[1]);
			}else{
				Spque(x,x+2,1);
				o=root[1]->son[1]->son[0];
				p=&pool[cnt++];
				o->d=abs(Query(x+2,0)-Query(x+1,0));
				p->d=abs(Query(x+3,0)-Query(x+2,0));
				o->son[1]=p;
				p->pnt=o;
				Update(p),Update(o),Update(o->pnt),Update(root[1]);
			}
		}
		if(strcmp(ch,"max")==0){
			Spque(x,y+2,0);
			outp(root[0]->son[1]->son[0]->max-root[0]->son[1]->son[0]->min);
		}
		if(strcmp(ch,"min")==0){
			Spque(x,y+1,1);
			outp(root[1]->son[1]->son[0]->min);
		}
	}
	return 0;
}
