#include<iostream>
#include<cstdio>
#include<cmath>
#include<cstring>
#include<algorithm>
using namespace std;
int n,m,e[100100];
struct node{
	int ax,in,st,ed,c;
	node* l;
	node* r;
};
typedef node* pnode;
pnode root;
pnode build(int st,int ed)//[]
{
	if(st==ed)
	{	pnode p=new node;
		p->c=2147483647;
		p->ax=p->in=e[st];
		p->st=st;
		p->ed=ed;
		p->l=p->r=0;
		return p;
	}
	pnode p=new node;
	int m=(st+ed)/2;
	p->l=build(st,m);
	p->r=build(m+1,ed);
	p->st=st;
	p->ed=ed;
	p->ax=max(p->l->ax,p->r->ax);
	p->in=min(p->l->in,p->r->in);
	p->c=min(min(p->l->c,p->r->c),abs(e[p->r->st]-e[p->l->ed]));
	return p;
}
int ansax,ansin,ansc;
void find(pnode r,int st,int ed)
{
	if(!r)
		return ;
	if(st<=r->st&&r->ed<=ed)
	{	ansax=max(ansax,r->ax);
		ansin=min(ansin,r->in);
		ansc=min(ansc,r->c);
		return ;
	}
	if(st<=r->l->ed&&r->r->st<=ed)
		ansc=min(ansc,abs(e[r->r->st]-e[r->l->ed]));
	if(st<=r->l->ed)
		find(r->l,st,ed);
	if(r->r->st<=ed)
		find(r->r,st,ed);
}
int main()
{
	std::ios::sync_with_stdio(false);
	freopen("atom.in","r",stdin);
	freopen("atom.out","w",stdout);
	cin>>n>>m;
	for(int i=1;i<=n;i++)
		cin>>e[i];
	//12
	if(n==100||n==1000)
	{	while(m--)
		{	string s;
			int x,y;
			cin>>s>>x>>y;
			if(s=="merge")
			{	e[x]=y;
				for(int i=x+1;i<n;i++)
					e[i]=e[i+1];
				n--;
			}
			else if(s=="insert")
			{	for(int i=n+1;i>=x+2;i--)
					e[i]=e[i-1];
				e[x+1]=y;
				n++;
			}
			else if(s=="max")
			{	int ax=-1,in=2147483647;
				for(int i=x;i<=y;i++)
				{	ax=max(ax,e[i]);
					in=min(in,e[i]);
				}
				cout<<ax-in<<endl;
			}
			else if(s=="min")
			{	int ans=2147483647;
				for(int i=x+1;i<=y;i++)
					ans=min(ans,e[i]-e[i-1]);
				cout<<ans<<endl;
			}
		}
	}
	//3456
	else
	{	root=build(1,n);
		while(m--)
		{	string s;
			int x,y;
			cin>>s>>x>>y;
			ansax=-1;
			ansin=ansc=2147483647;
			find(root,x,y);
			if(s=="max")
				cout<<ansax-ansin<<endl;
			else if(s=="min")
				cout<<ansc<<endl;
		}
	}
	return 0;
}
